--creacio taules

create table usuaris
  (usuari_id        number

	,usuari				    varchar2(255)
		constraint usuari_nn not null

	,contrassenya			varchar2(255)
		constraint u_contrassenya_nn not null
    
  ,rol              varchar2(255)
		constraint u_roll_nn not null

	,nom				      varchar2(255)
		constraint u_nom_nn not null

	,cognom1			    varchar2(255)
		constraint u_cognom1_nn not null

	,cognom2			    varchar2(255)
		constraint u_cognom2__nn not null

	, constraint usuari_id_pk PRIMARY KEY (usuari_id)
);

   
     
    create table anys_academics
    (any_academic_id      number
    
    ,any_academic         varchar2(20)
    constraint any_academi_nn not null
    
    --,constraint any_academic_uk unique (any_academic)
    
    ,constraint any_academic_id_pk PRIMARY KEY (any_academic_id)
    );
    
   
    create table avaluacions_any_academic
    (avaluacio_any_academic_id     number
    
    ,any_academic_id                number
    
    ,nom                varchar2(255)
    constraint nom_avaluacio_nn_ not null
    
    ,data_inici                     date
    
    ,data_fi                        date
    
    ,constraint avaluacio_any_academic_id_pk PRIMARY KEY (avaluacio_any_academic_id)
    );
        
    create table butlletins
    (butlleti_id                    number
    
    ,periode_avaluacio_id           number
    constraint b_periode_avaluacio_id_nn not null
    
    ,faltes_justificades            number
    
    ,faltes_injustificades          number
    
    ,comentari                      varchar2(1000)
    
    ,promociona                     number
    constraint butlletins_promociona_ck check (promociona in (0, 1))
    
    ,nota_global                    number
    
    ,publicat                       number
    constraint butlletins_publicat_ck check (publicat in (0, 1))
    
    ,constraint butlleti_id_pk PRIMARY KEY (butlleti_id)
    );
    
    create table assignatures
    (assignatura_id                 number
    
    ,nom                            varchar2(255)
    constraint assignatura_nom_nn not null
    
    ,constraint assignatura_id_pk PRIMARY KEY (assignatura_id)
    );
    
    create table nivells
    (nivell_id                  number
    
    ,nom                        varchar2(255)
    constraint nivell_nom_nn not null
    
    ,assignatura_id             number
    constraint n_assignatura_id_nn not null
    
    ,constraint nivell_id_pk PRIMARY KEY (nivell_id)
    );
    
  
    
    create table unitats_didactiques
    (unitat_didactica_id          number
    
    ,nivell_id        number
    constraint ud_assignatura_nn not null
    
    ,numero                       number
    constraint ud_numero_nn not null
    ,titol                        varchar2(255)
    
    ,data_alta                    date
    
    ,data_baixa                   date
    
    ,constraint unitat_didactica_id_pk PRIMARY KEY (unitat_didactica_id)
    );
    
    create table activitats_avaluadores
    (activitat_avaluadora_id      number
    
    ,nom                          varchar2(255)
    constraint aa_nom_nn not null
    
    ,data_alta                    date
    
    ,data_baixa                   date
    
    ,unitat_didactica_id          number
    constraint aa_unitat_didactica_id_nn not null
    
    ,constraint activitat_avaluadora_id_pk PRIMARY KEY (activitat_avaluadora_id)
    );
    
    create table tutors
    (tutor_id               number
    
    ,pare_id                number
    constraint t_pare_id_nn not null
    
    ,alumne_id              number
    constraint t_alumne_id_nn not null
    
    ,constraint t_pare_id_alumne_id_uq unique (pare_id, alumne_id)
    
    ,constraint t_tutor_id_pk PRIMARY KEY (tutor_id)
    );
    
    create table imparteix
    (imparteix_id           number
    
    ,professor_id           number
    constraint i_professor_id_nn not null
    
    ,assignatura_id         number
    constraint i_assignatura_id_nn not null
    
    ,constraint imparteix_id_pk PRIMARY KEY (imparteix_id)
    );
    
   create table matricules
   (matricula_id          number
   
   ,alumne_id              number
   constraint m_alumne_id_nn not null
   
   ,nivell_id              number
   constraint m_nivell_id_nn not null
   
   ,any_academic_id      number
   constraint m_any_academic_nn not null
   
   ,professor_id          number
   constraint m_professor_id_nn not null
   
   ,constraint m_matricula_id_pk primary key (matricula_id)
   );
   
    
    CREATE TABLE "PERIODES_AVALUACIONS"
  (
    "PERIODE_AVALUACIO_ID"      NUMBER,
    "MATRICULA_ID"              NUMBER CONSTRAINT "PA_MATRICULA_ID_NN" NOT NULL ENABLE,
    "AVALUACIO_ANY_ACADEMIC_ID" NUMBER CONSTRAINT "PA_AV_ANY_ACADEMIC_ID_NN" NOT NULL ENABLE,
    CONSTRAINT "PERIODE_AVALUACIO_ID_PK" PRIMARY KEY ("PERIODE_AVALUACIO_ID")
    );
    
    create table arees_assignatures
    (area_assignatura_id number
    
    ,nivell_id            number
    constraint aa_nivell_id_nn not null
    
    ,nom                      varchar2(255)
    constraint area_nom_nn not null
    
    ,descripcio               varchar2(255)

    ,data_alta                    date
    
    ,data_baixa                   date
 
    ,constraint area_assignatura_id_pk primary  key (area_assignatura_id)
    );
   
    
    CREATE TABLE "QUALIFICACIONS_AREES"
  (
    "QUALIFICACIO_AREA_ID" NUMBER,
    "AREA_ASSIGNATURA_ID"  NUMBER CONSTRAINT "QA_AREA_ASSIGNATURA_NN" NOT NULL ENABLE,
    "PERIODE_AVALUACIO_ID" NUMBER CONSTRAINT "QA_PERIODE_AVALUACIO_ID_NN" NOT NULL ENABLE,
    "NOTA"                NUMBER CONSTRAINT "QA_NOTA_NN" NOT NULL ENABLE,
    "DATA_ALTA"            DATE CONSTRAINT "QA_DATA_ALTA_NN" NOT NULL ENABLE,
    CONSTRAINT "QUALIFICACIO_AREA_ID_PK" PRIMARY KEY ("QUALIFICACIO_AREA_ID")
    );
    
    CREATE TABLE "AREES_ACTIVITATS"
  (
    "AREA_ACTIVITAT_ID"       NUMBER,
    "AREA_ASSIGNATURA_ID"     NUMBER CONSTRAINT "AAC_AREA_ASSIGNATURA_ID_NN" NOT NULL ENABLE,
    "ACTIVITAT_AVALUADORA_ID" NUMBER CONSTRAINT "AAC_ACTIVITAT_AVALUADORA_ID_NN" NOT NULL ENABLE,
    "PERCENTATGE_PROGRAMACIO" NUMBER,
    CONSTRAINT "AAC_AREA_ACTIVITAT_ID_PK" PRIMARY KEY ("AREA_ACTIVITAT_ID")
    );
    
    create table notes_definitives_activitats
    (nota_definitiva_activitat_id       number
    
   ,periode_avaluacio_id                number
   constraint nda_periode_avaluacio_id_nn not null
   
    ,activitat_avaluadora_id            number
    constraint nda_activitat_avaluadora_id_nn not null
    
    ,mitjana                           NUMBER
    constraint nda_mitjana_nn not null
    
    ,nota_real                         NUMBER
    constraint nda_nota_real_nn not null
    
    ,constraint nda_nota_def_activitat_id_pk PRIMARY KEY (nota_definitiva_activitat_id)
    );
    
    
    create table qualificacions_arees_activitat
    (qualificacio_area_activitat_id     number
    
    ,area_activitat_id                  number
    constraint qaa_area_activitat_id_nn not null
    
    ,periode_avaluacio_id                number
    constraint qaa_periode_avaluacio_id_nn not null
    
    ,nota                              NUMBER
    constraint qaa_nota_nn not null
    
    ,percentatge_real                  NUMBER
    
    
    ,constraint qaa_qual_arees_activitat_id_pk PRIMARY KEY (qualificacio_area_activitat_id)
    );
    
    create table mitjanes_arees_butlletins
    (mitjana_area_butlleti_id     number
    
    ,butlleti_id                      number
    constraint mab_butlleti_id_nn not null
    
    ,mitja                           NUMBER
    constraint mab_mitja_nn not null
    
    ,ponderacio_global               NUMBER
    constraint mab_ponderacio_global_nn not null
    
    ,constraint mab_mitj_arees_butll_id_pk PRIMARY KEY (mitjana_area_butlleti_id)
    );
    
    
   
    