package com.andujar.springmvc.domain;

import java.io.Serializable;
import java.util.Date;
import java.util.Map;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.MapKeyColumn;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.andujar.springmvc.exception.Excepcio;


@Entity
@Table(name="activitats_avaluadores")
public class ActivitatAvaluadora implements Serializable{

	
	private static final long serialVersionUID = 5283316084227250641L;
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_activitats_avaluadores"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "activitat_avaluadora_id")
	private Long id;
	
	
	
	@ManyToOne 
	@JoinColumn (name="unitat_didactica_id")
	private UnitatDidactica unitatDidactica;
	
	@Column (name = "nom")
	private String nom;
	
	@Column (name = "data_alta")
	private Date dataAlta;
	
	@Column (name = "data_baixa")
	private Date dataBaixa;

	
	@OneToMany (mappedBy="activitatAvaluadora", fetch=FetchType.EAGER) 
	@MapKeyColumn(name="AREA_ASSIGNATURA_ID")
	private Map <Long, AreaActivitat> areesActivitats;
	
	
	
	public ActivitatAvaluadora() {
		super();
	}



	public ActivitatAvaluadora(UnitatDidactica unitatDidactica, String nom,
			Date dataAlta, Date dataBaixa) throws Excepcio {
		super();
		if (nom == "") throw new Excepcio ("El nom de l'activitat avaluadora no pot ser buit.");
		this.unitatDidactica = unitatDidactica;
		this.nom = nom;
		this.dataAlta = dataAlta;
		this.dataBaixa = dataBaixa;
	}



	public Long getId() {
		return id;
	}



	public UnitatDidactica getUnitatDidactica() {
		return unitatDidactica;
	}



	public void setUnitatDidactica(UnitatDidactica unitatDidactica) {
		this.unitatDidactica = unitatDidactica;
	}



	public String getNom() {
		return nom;
	}



	public void setNom(String nom) {
		this.nom = nom;
	}



	public Date getDataAlta() {
		return dataAlta;
	}



	public void setDataAlta(Date dataAlta) {
		this.dataAlta = dataAlta;
	}



	public Date getDataBaixa() {
		return dataBaixa;
	}



	public void setDataBaixa(Date dataBaixa) {
		this.dataBaixa = dataBaixa;
	}

	

	public Map<Long, AreaActivitat> getAreesActivitats() {
		return areesActivitats;
	}



	public void setAreesActivitats(Map<Long, AreaActivitat> areesActivitats) {
		this.areesActivitats = areesActivitats;
	}



	@Override
	public String toString() {
		return "ActivitatAvaluadora [id=" + id + ", unitatDidactica="
				+ unitatDidactica + ", nom=" + nom + ", dataAlta=" + dataAlta
				+ ", dataBaixa=" + dataBaixa + "]";
	}
	
	
	
	    
	    
	    
	    
	   
	

}
