package com.andujar.springmvc.domain;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


@Entity
@Table(name="AREES_ACTIVITATS")
public class AreaActivitat {
	
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_AREES_ACTIVITATS"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "AREA_ACTIVITAT_ID")
	private Long id;
	
	
	@ManyToOne
	@JoinColumn (name = "AREA_ASSIGNATURA_ID")
	private AreaAssignatura areaAssignatura;
	
	
	
	
	@ManyToOne
	@JoinColumn (name = "ACTIVITAT_AVALUADORA_ID")
	private ActivitatAvaluadora activitatAvaluadora; 
	
	@Column (name = "PERCENTATGE_PROGRAMACIO")
	private double percentatgeProgramacio;

	
	public AreaActivitat() {
		super();
	}

	public AreaActivitat(AreaAssignatura areaAssignatura,
			ActivitatAvaluadora activitatAvaluadora,
			double percentatgeProgramacio) {
		super();
		this.areaAssignatura = areaAssignatura;
		this.activitatAvaluadora = activitatAvaluadora;
		this.percentatgeProgramacio = percentatgeProgramacio;
	}

	public Long getId() {
		return id;
	}

	public AreaAssignatura getAreaAssignatura() {
		return areaAssignatura;
	}

	public void setAreaAssignatura(AreaAssignatura areaAssignatura) {
		this.areaAssignatura = areaAssignatura;
	}

	public ActivitatAvaluadora getActivitatAvaluadora() {
		return activitatAvaluadora;
	}

	public void setActivitatAvaluadora(ActivitatAvaluadora activitatAvaluadora) {
		this.activitatAvaluadora = activitatAvaluadora;
	}

	public double getPercentatgeProgramacio() {
		return percentatgeProgramacio;
	}

	public void setPercentatgeProgramacio(double percentatgeProgramacio) {
		this.percentatgeProgramacio = percentatgeProgramacio;
	}

	@Override
	public String toString() {
		return "AreaActivitat [id=" + id + ", areaAssignatura="
				+ areaAssignatura + ", percentatgeProgramacio="
				+ percentatgeProgramacio + "]";
	}
	
	
	
	
	
	
	
	    
	   

}
