package com.andujar.springmvc.domain;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.andujar.springmvc.exception.Excepcio;


@Entity
@Table(name="arees_assignatures")
public class AreaAssignatura implements Serializable{


	private static final long serialVersionUID = -6671126863202187401L;
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "SQ_AREES_ASSIGNATURES"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "area_assignatura_id")
	private Long id;
	
	@ManyToOne
	@JoinColumn (name = "nivell_id")
	private Nivell nivell;
	
	
	@Column (name = "nom")
	private String nom;
	
	@Column (name="descripcio")
	private String descripcio;
	
	@Column (name="data_alta ")
	private Date dataAlta ;
	
	@Column (name="data_baixa ")
	private Date dataBaixa ;

	
	
	
	public AreaAssignatura() {
		super();
	}

	public AreaAssignatura (Nivell nivell, String nom, String descripcio,
			Date data_alta, Date data_baixa) throws Excepcio  
	{
		
		super();
		//Comprova que el nom de l'rea no estigui buit
		if (nom =="")throw new Excepcio ("El nom de l'rea no pot estar buit");

		this.nivell = nivell;
		this.nom = nom;
		this.descripcio = descripcio;
		this.dataAlta = data_alta;
		this.dataBaixa = data_baixa;
	}

	public Long getId() {
		return id;
	}

	public Nivell getNivell() {
		return nivell;
	}

	public void setNivell(Nivell nivell) {
		this.nivell = nivell;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public Date getDataAlta() {
		return dataAlta;
	}

	public void setDataAlta(Date data_alta) {
		this.dataAlta = data_alta;
	}

	public Date getDataBaixa() {
		return dataBaixa;
	}

	public void setDataBaixa(Date data_baixa) {
		this.dataBaixa = data_baixa;
	}

	@Override
	public String toString() {
		return "AreaAssignatura [id=" + id + ", nivell=" + nivell + ", nom="
				+ nom + ", descripcio=" + descripcio + ", data_alta="
				+ dataAlta + ", data_baixa=" + dataBaixa + "]";
	}
	
	
	
	
	

    
    

   
 
	
	
	
	
	
	

}
