package com.andujar.springmvc.domain;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


@Entity
@Table(name="avaluacions_any_academic")
public class AvaluacioAnyAcademic implements Serializable{
	
	
	
	private static final long serialVersionUID = 6524710666250390221L;
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_avaluacions_any_academic"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "avaluacio_any_academic_id")
	private Long id;
	
	@ManyToOne
	@JoinColumn (name = "any_academic_id")
	private AnyAcademic anyAcademic;
	
	@Enumerated (EnumType.STRING)
	@Column (name = "nom")
	private Avaluacions nom;
	   
	@Column (name = "data_inici")
	private Date dataInici;
	
	@Column (name = "data_fi")
	private Date dataFi;

	public AvaluacioAnyAcademic() {
		super();
	}

	public AvaluacioAnyAcademic(Avaluacions nom, Date dataInici, Date datFi) {
		super();
		this.nom = nom;
		this.dataInici = dataInici;
		this.dataFi = datFi;
	}

	public Long getId() {
		return id;
	}

	
	public AnyAcademic getAnyAcademic() {
		return anyAcademic;
	}

	public void setAnyAcademic(AnyAcademic anyAcademic) {
		this.anyAcademic = anyAcademic;
	}

	public Avaluacions getNom() {
		return nom;
	}

	public void setNom(Avaluacions nom) {
		this.nom = nom;
	}

	public Date getDataInici() {
		return dataInici;
	}

	public void setDataInici(Date dataInici) {
		this.dataInici = dataInici;
	}

	public Date getDatFi() {
		return dataFi;
	}

	public void setDatFi(Date datFi) {
		this.dataFi = datFi;
	}
	    
	@Override
	public String toString() {
		return "AvaluacioAnyAcademic [id=" + id + ", nom=" + nom
				+ ", dataInici=" + dataInici + ", datFi=" + dataFi + "]";
	}
    
	   

}
