package com.andujar.springmvc.domain;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

@Entity
@Table(name="butlletins")
public class Butlleti {
	
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_butlletins"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "butlleti_id")
	private Long id;
	
	@OneToOne
	@JoinColumn (name = "periode_avaluacio_id")
	private PeriodeAvaluacio periodeAvaluacio;
    
	@Column (name = "faltes_justificades")
	private int faltesJustificades;
	
	@Column (name = "faltes_injustificades")
	private int faltesInjustificades;
	
	@Column (name = "comentari")
	private String comentari;
    
	@Column (name = "promociona")
	private int promociona;
   
	@Column (name = "nota_global")
	private Double notaGlobal;
	
	@Column (name = "publicat")
	private int publicat;

	public Butlleti() {
		super();
	}
	
	
	
	public Butlleti(PeriodeAvaluacio periodeAvaluacio, int faltesJustificades,
			int faltesInjustificades, String comentari, int promociona,
			Double notaGlobal, int publicat) {
		super();
		this.periodeAvaluacio = periodeAvaluacio;
		this.faltesJustificades = faltesJustificades;
		this.faltesInjustificades = faltesInjustificades;
		this.comentari = comentari;
		this.promociona = promociona;
		this.notaGlobal = notaGlobal;
		this.publicat = publicat;
	}

	public Long getId() {
		return id;
	}

	public PeriodeAvaluacio getPeriodeAvaluacio() {
		return periodeAvaluacio;
	}

	public void setPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio) {
		this.periodeAvaluacio = periodeAvaluacio;
	}

	public int getFaltesJustificades() {
		return faltesJustificades;
	}

	public void setFaltesJustificades(int faltesJustificades) {
		this.faltesJustificades = faltesJustificades;
	}

	public int getFaltesInjustificades() {
		return faltesInjustificades;
	}

	public void setFaltesInjustificades(int faltesInjustificades) {
		this.faltesInjustificades = faltesInjustificades;
	}

	public String getComentari() {
		return comentari;
	}

	public void setComentari(String comentari) {
		this.comentari = comentari;
	}

	public int getPromociona() {
		return promociona;
	}

	public void setPromociona(int promociona) {
		this.promociona = promociona;
	}

	public Double getNotaGlobal() {
		return notaGlobal;
	}

	public void setNotaGlobal(Double notaGlobal) {
		this.notaGlobal = notaGlobal;
	}

	public int getPublicat() {
		return publicat;
	}

	public void setPublicat(int publicat) {
		this.publicat = publicat;
	}

	@Override
	public String toString() {
		return "Butlleti [id=" + id + ", periodeAvaluacio=" + periodeAvaluacio
				+ ", faltesJustificades=" + faltesJustificades
				+ ", faltesInjustificades=" + faltesInjustificades
				+ ", comentari=" + comentari + ", promociona=" + promociona
				+ ", notaGlobal=" + notaGlobal + ", publicat=" + publicat + "]";
	}
	
	
	


}
