package com.andujar.springmvc.domain;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


@Entity
@Table(name="imparteix")
public class Imparteix implements Serializable{
	
	private static final long serialVersionUID = 2880848671075244372L;

	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_imparteix"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "imparteix_id")
	private Long id;
    
	@ManyToOne
	@JoinColumn (name = "professor_id")
	private Usuari professor;
	
	@JoinColumn (name = "assignatura_id")
	@ManyToMany(cascade=CascadeType.ALL, fetch=FetchType.EAGER)
	private List<Assignatura> assignatures = new ArrayList<Assignatura>();

	public Imparteix() {
		super();
	}

	public Imparteix(Usuari professor, List<Assignatura> assignatures) {
		super();
		this.professor = professor;
		this.assignatures = assignatures;
	}

	public Long getId() {
		return id;
	}

	public Usuari getProfessor() {
		return professor;
	}

	public void setProfessor(Usuari professor) {
		this.professor = professor;
	}

	public List<Assignatura> getAssignatures() {
		return assignatures;
	}

	public void setAssignatures(List<Assignatura> assignatures) {
		this.assignatures = assignatures;
	}

	@Override
	public String toString() {
		return "Imparteix [id=" + id + ", professor=" + professor
				+ ", assignatures=" + assignatures + "]";
	}
	
	
	
	
    
    

}
