package com.andujar.springmvc.domain;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


@Entity
@Table(name="matricules")
public class Matricula implements Serializable{
	

	private static final long serialVersionUID = 1477974732373555896L;

	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_MATRICULES"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "matricula_id")
	private Long id ;

	@ManyToOne
	@JoinColumn (name="alumne_id")
	private Usuari alumne;
	
	@OneToOne
	@JoinColumn (name="professor_id")
	private Usuari professor;
	
	@ManyToOne
	@JoinColumn (name="any_academic_id")
	private AnyAcademic anyAcademic;
	
	@ManyToOne
	@JoinColumn (name="nivell_id")
	private Nivell nivell;

	
	
	public Matricula() {
		super();
	}

	
	public Matricula(Usuari alumne, Usuari professor, AnyAcademic anyAcademic,
			Nivell nivell) {
		super();
		this.alumne = alumne;
		this.professor = professor;
		this.anyAcademic = anyAcademic;
		this.nivell = nivell;
	}


	public Long getId() {
		return id;
	}


	public Usuari getAlumne() {
		return alumne;
	}


	public void setAlumne(Usuari alumne) {
		this.alumne = alumne;
	}


	public Usuari getProfessor() {
		return professor;
	}


	public void setProfessor(Usuari professor) {
		this.professor = professor;
	}


	public AnyAcademic getAnyAcademic() {
		return anyAcademic;
	}


	public void setAnyAcademic(AnyAcademic anyAcademic) {
		this.anyAcademic = anyAcademic;
	}


	public Nivell getNivell() {
		return nivell;
	}


	public void setNivell(Nivell nivell) {
		this.nivell = nivell;
	}


	public static long getSerialversionuid() {
		return serialVersionUID;
	}


	@Override
	public String toString() {
		return "Matricula [id=" + id + ", alumne=" + alumne + ", professor="
				+ professor + ", anyAcademic=" + anyAcademic + ", nivell="
				+ nivell + "]";
	}
	
	
	
	
	
	
	
	  
	   
	  
	   
}
