package com.andujar.springmvc.domain;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

@Entity
@Table(name="mitjanes_arees_butlletins")
public class MitjaAreaButlleti implements Serializable{
	
	private static final long serialVersionUID = -1961898957353415548L;



	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_mitjanes_arees_butlletins"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "mitjana_area_butlleti_id")
	private Long id;
	
	@ManyToOne 
	@JoinColumn (name="butlleti_id")
	private Butlleti butlleti;
	
	@Column (name = "mitja")
	private Double mitja;
    
	@Column (name = "mitjaponderacio_global")
	private Double ponderacioGlobal;

	public MitjaAreaButlleti() {
		super();
	}

	public MitjaAreaButlleti(Butlleti butlleti, Double mitja,
			Double ponderacioGlobal) {
		super();
		this.butlleti = butlleti;
		this.mitja = mitja;
		this.ponderacioGlobal = ponderacioGlobal;
	}

	public Long getId() {
		return id;
	}

	public Butlleti getButlleti() {
		return butlleti;
	}

	public void setButlleti(Butlleti butlleti) {
		this.butlleti = butlleti;
	}

	public Double getMitja() {
		return mitja;
	}

	public void setMitja(Double mitja) {
		this.mitja = mitja;
	}

	public Double getPonderacioGlobal() {
		return ponderacioGlobal;
	}

	public void setPonderacioGlobal(Double ponderacioGlobal) {
		this.ponderacioGlobal = ponderacioGlobal;
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	@Override
	public String toString() {
		return "MitjaAreaButlleti [id=" + id + ", butlleti=" + butlleti
				+ ", mitja=" + mitja + ", ponderacioGlobal=" + ponderacioGlobal
				+ "]";
	}
	
	
    
    

}


