package com.andujar.springmvc.domain;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


@Entity
@Table(name="nivells")
public class Nivell implements Serializable{
	
	
	private static final long serialVersionUID = 8405498438564453319L;

	
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_nivells"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "nivell_id")
	private Long id;
	
	@ManyToOne 
	@JoinColumn (name="assignatura_id")
	private Assignatura assignatura;
	
	@Column (name = "nom")
	private String nom;

	
	
	public Nivell() {
		super();
	}

	public Nivell( Assignatura assignatura, String nom) {
		super();
		
		this.assignatura = assignatura;
		this.nom = nom;
	}

	public Long getId() {
		return id;
	}

	
	public Assignatura getAssignatura() {
		return assignatura;
	}

	public void setAssignatura(Assignatura assignatura) {
		this.assignatura = assignatura;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	@Override
	public String toString() {
		return "Nivell [id=" + id + ", assignatura=" + assignatura + ", nom="
				+ nom + "]";
	}
	
	
	
	

}
