package com.andujar.springmvc.domain;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


@Entity
@Table(name="notes_definitives_activitats")
public class NotaDefinitivaActivitat implements Serializable{

	private static final long serialVersionUID = -8859405091348455515L;


	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_notes_definitives_act"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "nota_definitiva_activitat_id")
	private Long id;
	
	@ManyToOne 
	@JoinColumn (name="periode_avaluacio_id")
	private PeriodeAvaluacio periodeAvaluacio;
	
	@ManyToOne 
	@JoinColumn (name="activitat_avaluadora_id")
	private ActivitatAvaluadora activitatAvaluadora;
	
	
	//Representa la mitjana calculada a aprtir de les notes obtingudes en cada rea de l'activitat
	@Column (name = "mitjana")
	private Double mitjana;  
	
	//Representa la nota final que ha decidit el docent i que pot diferir de la mitjana calculada (es pot entendre com un arrodoniment de la nota)
	@Column (name = "nota_real")
	private Double notaReal;

	public NotaDefinitivaActivitat() {
		super();
	}

	public NotaDefinitivaActivitat(PeriodeAvaluacio periodeAvaluacio,
			ActivitatAvaluadora activitatAvaluadora, Double mitjana,
			Double notaReal) {
		super();
		this.periodeAvaluacio = periodeAvaluacio;
		this.activitatAvaluadora = activitatAvaluadora;
		this.mitjana = mitjana;
		this.notaReal = notaReal;
	}

	public Long getId() {
		return id;
	}

	public PeriodeAvaluacio getPeriodeAvaluacio() {
		return periodeAvaluacio;
	}

	public void setPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio) {
		this.periodeAvaluacio = periodeAvaluacio;
	}

	public ActivitatAvaluadora getActivitatAvaluadora() {
		return activitatAvaluadora;
	}

	public void setActivitatAvaluadora(ActivitatAvaluadora activitatAvaluadora) {
		this.activitatAvaluadora = activitatAvaluadora;
	}

	public Double getMitjana() {
		return mitjana;
	}

	public void setMitjana(Double mitjana) {
		this.mitjana = mitjana;
	}

	public Double getNotaReal() {
		return notaReal;
	}

	public void setNotaReal(Double notaReal) {
		this.notaReal = notaReal;
	}

	@Override
	public String toString() {
		return "NotaDefinitivaActivitat [id=" + id + ", periodeAvaluacio="
				+ periodeAvaluacio + ", activitatAvaluadora="
				+ activitatAvaluadora + ", mitjana=" + mitjana + ", notaReal="
				+ notaReal + "]";
	}  
	    
	    
	   
}
