package com.andujar.springmvc.domain;

import java.io.Serializable;
import java.util.Map;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.MapKeyColumn;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;



@Entity
@Table(name="PERIODES_AVALUACIONS")
public class PeriodeAvaluacio implements Serializable{
	
	private static final long serialVersionUID = -8045124507287949859L;
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_PERIODES_AVALUACIONS"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "PERIODE_AVALUACIO_ID")
	private Long id;
	
    
    @ManyToOne 
	@JoinColumn (name="MATRICULA_ID")
	private Matricula matricula;
	
	
	@ManyToOne 
	@JoinColumn (name="AVALUACIO_ANY_ACADEMIC_ID")
	private AvaluacioAnyAcademic avaluacioAnyAcademic;
	
	
	 
	@OneToMany (mappedBy="periodeAvaluacio", fetch=FetchType.EAGER) 
	@MapKeyColumn(name="AREA_ACTIVITAT_ID")
	private Map <Long, QualificacioAreaActivitat> qualificacionsAreesActivitats;
	
	
	public PeriodeAvaluacio() {
		super();
	}
	public PeriodeAvaluacio(Matricula matricula,
			AvaluacioAnyAcademic avaluacioAnyAcademic) {
		super();
		this.matricula = matricula;
		this.avaluacioAnyAcademic = avaluacioAnyAcademic;
	}
	public Long getId() {
		return id;
	}
	public Matricula getMatricula() {
		return matricula;
	}
	public void setMatricula(Matricula matricula) {
		this.matricula = matricula;
	}
	public AvaluacioAnyAcademic getAvaluacioAnyAcademic() {
		return avaluacioAnyAcademic;
	}
	public void setAvaluacioAnyAcademic(AvaluacioAnyAcademic avaluacioAnyAcademic) {
		this.avaluacioAnyAcademic = avaluacioAnyAcademic;
	}
	public static long getSerialversionuid() {
		return serialVersionUID;
	}
	
	public Map<Long, QualificacioAreaActivitat> getQualificacionsAreesActivitats() {
		return qualificacionsAreesActivitats;
	}
	public void setQualificacionsAreesActivitats(
			Map<Long, QualificacioAreaActivitat> qualificacionsAreesActivitats) {
		this.qualificacionsAreesActivitats = qualificacionsAreesActivitats;
	}
	@Override
	public String toString() {
		return "PeriodeAvaluacio [id=" + id + ", matricula=" + matricula
				+ ", avaluacioAnyAcademic=" + avaluacioAnyAcademic
				+ ", qualificacionsAreesActivitats="
				+ qualificacionsAreesActivitats + "]";
	}
	
	
	
	
	   
	    
}
