package com.andujar.springmvc.domain;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


@Entity
@Table(name="QUALIFICACIONS_AREES")
public class QualificacioArea implements Serializable{
	
	
	private static final long serialVersionUID = -3316410894028355149L;
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_QUALIFICACIONS_AREES"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "QUALIFICACIO_AREA_ID")
	private Long id;
	
	
	@ManyToOne 
	@JoinColumn (name="AREA_ASSIGNATURA_ID")
	private AreaAssignatura areaAssignatura;
	
	@ManyToOne 
	@JoinColumn (name="PERIODE_AVALUACIO_ID")
	private PeriodeAvaluacio periodeAvaluacio;
	
	@Column (name = "NOTA")
	private Double nota;
	
	@Column (name = "DATA_ALTA")
	private Date dataAlta;

	public QualificacioArea() {
		super();
	}

	public QualificacioArea(AreaAssignatura areaAssignatura,
			PeriodeAvaluacio periodeAvaluacio, Double nota, Date dataAlta) {
		super();
		this.areaAssignatura = areaAssignatura;
		this.periodeAvaluacio = periodeAvaluacio;
		this.nota = nota;
		this.dataAlta = dataAlta;
	}

	public Long getId() {
		return id;
	}

	public AreaAssignatura getAreaAssignatura() {
		return areaAssignatura;
	}

	public void setAreaAssignatura(AreaAssignatura areaAssignatura) {
		this.areaAssignatura = areaAssignatura;
	}

	public PeriodeAvaluacio getPeriodeAvaluacio() {
		return periodeAvaluacio;
	}

	public void setPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio) {
		this.periodeAvaluacio = periodeAvaluacio;
	}

	public Double getNota() {
		return nota;
	}

	public void setNota(Double nota) {
		this.nota = nota;
	}

	public Date getDataAlta() {
		return dataAlta;
	}

	public void setDataAlta(Date dataAlta) {
		this.dataAlta = dataAlta;
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	@Override
	public String toString() {
		return "QualificacioArea [id=" + id + ", areaAssignatura="
				+ areaAssignatura + ", periodeAvaluacio=" + periodeAvaluacio
				+ ", nota=" + nota + ", dataAlta=" + dataAlta + "]";
	}
	
	
	
	

}
