package com.andujar.springmvc.domain;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


@Entity
@Table(name="qualificacions_arees_activitat")
public class QualificacioAreaActivitat implements Serializable{
	

	private static final long serialVersionUID = 7952326397196818571L;
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_qualificacions_arees_act"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "qualificacio_area_activitat_id")
	private Long id;
	
	@ManyToOne
	@JoinColumn (name="area_activitat_id")
	private AreaActivitat areaActivitat;
	
	@ManyToOne 
	@JoinColumn (name="periode_avaluacio_id")
	private PeriodeAvaluacio periodeAvaluacio;

	@Column (name = "nota")
	private Double nota;
    
	@Column (name = "percentatge_real")
	private Double percentatgeReal;

	public QualificacioAreaActivitat() {
		super();
	}

	public QualificacioAreaActivitat(AreaActivitat areaActivitat,
			PeriodeAvaluacio periodeAvaluacio, Double nota,
			Double percentatgeReal) {
		super();
		this.areaActivitat = areaActivitat;
		this.periodeAvaluacio = periodeAvaluacio;
		this.nota = nota;
		this.percentatgeReal = percentatgeReal;
	}

	public Long getId() {
		return id;
	}

	public AreaActivitat getAreaActivitat() {
		return areaActivitat;
	}

	public void setAreaActivitat(AreaActivitat areaActivitat) {
		this.areaActivitat = areaActivitat;
	}

	public PeriodeAvaluacio getPeriodeAvaluacio() {
		return periodeAvaluacio;
	}

	public void setPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio) {
		this.periodeAvaluacio = periodeAvaluacio;
	}

	public Double getNota() {
		return nota;
	}

	public void setNota(Double nota) {
		this.nota = nota;
	}

	public Double getPercentatgeReal() {
		return percentatgeReal;
	}

	public void setPercentatgeReal(Double percentatgeReal) {
		this.percentatgeReal = percentatgeReal;
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	@Override
	public String toString() {
		return "QualificacioAreaActivitat [id=" + id + ", areaActivitat="
				+ areaActivitat + ", periodeAvaluacio=" + periodeAvaluacio
				+ ", nota=" + nota + ", percentatgeReal=" + percentatgeReal
				+ "]";
	}
    
    

}
