package com.andujar.springmvc.domain;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.andujar.springmvc.exception.Excepcio;


@Entity
@Table(name="unitats_didactiques")
public class UnitatDidactica implements Serializable {


	private static final long serialVersionUID = 6707831686158749607L;
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_unitats_didactiques"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "unitat_didactica_id")
	private Long id;
	
	
	@ManyToOne
	@JoinColumn (name="nivell_id")
	private Nivell nivell;
	 
	@Column (name = "numero" )
	private Long numero;
	
	@Column (name = "titol" )
	private String titol;
   
	@Column (name = "data_alta" )
	private Date dataAlta;
    
    @Column (name= "data_baixa")
    private Date dataBaixa;
    
	public UnitatDidactica() {
		super();
	}

	public UnitatDidactica(Nivell nivell, Long numero, String titol,
			Date data_alta, Date data_baixa) throws Excepcio {
		super();
		if(numero == null) throw new Excepcio ("El nmero de la unitat didctica no pot ser buit.");
		this.nivell = nivell;
		this.numero = numero;
		this.titol = titol;
		this.dataAlta = data_alta;
		this.dataBaixa = data_baixa;
	}

	public Long getId() {
		return id;
	}

	public Nivell getNivell() {
		return nivell;
	}

	public void setNivell(Nivell nivell) {
		this.nivell = nivell;
	}

	public Long getNumero() {
		return numero;
	}

	public void setNumero(Long numero) {
		this.numero = numero;
	}

	public String getTitol() {
		return titol;
	}

	public void setTitol(String titol) {
		this.titol = titol;
	}

	public Date getDataAlta() {
		return dataAlta;
	}

	public void setDataAlta(Date data_alta) {
		this.dataAlta = data_alta;
	}

	public Date getDataBaixa() {
		return dataBaixa;
	}

	public void setDataBaixa(Date data_baixa) {
		this.dataBaixa = data_baixa;
	}

	@Override
	public String toString() {
		return "UnitatDidactica [id=" + id + ", nivell=" + nivell + ", numero="
				+ numero + ", titol=" + titol + ", data_alta=" + dataAlta
				+ ", data_baixa=" + dataBaixa + "]";
	}

	
	
                       
    
   
	
	

}
