package com.andujar.springmvc.domain;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.andujar.springmvc.exception.Excepcio;


@Entity
@Table(name="usuaris")
public class Usuari implements Serializable {
	

	private static final long serialVersionUID = 4993867418799013193L;
	
	@GenericGenerator(name = "generator", strategy = "sequence-identity", parameters =  @Parameter(name = "sequence", value = "sq_usuaris"))
	@Id
	@GeneratedValue(generator = "generator")
	@Column (name = "usuari_id")
	private Long id;
	
	@Column (name = "usuari")
	private String usuari	;
	
	@Column (name = "contrassenya")
	private String contrassenya;
	
	
	@Column (name = "nom")
	private String nom;
	
	@Column (name = "cognom1")
	private String cognom1;
	
	@Column (name = "cognom2")
	private String cognom2;

	@Enumerated (EnumType.STRING)
	@Column (name = "rol")
	private PerfilUsuari perfil;
	
	public Usuari() {
		super();
	}

	
	public Usuari(String usuari, String contrassenya, PerfilUsuari perfil, String nom,
			String cognom1, String cognom2) throws Excepcio {
		super();
		
		if(	usuari == "" ||
			contrassenya  == "" ||
			nom  == "" ||
			cognom1  == "" ||
			cognom2  == "" ||
			perfil == null )
			throw new Excepcio ("Tots els camps d'usuari han d'estar plens.");
		this.usuari = usuari;
		this.contrassenya = contrassenya;
		this.perfil=perfil;
		this.nom = nom;
		this.cognom1 = cognom1;
		this.cognom2 = cognom2;
		
	}

	public Long getId() {
		return id;
	}

	public String getUsuari() {
		return usuari;
	}

	public void setUsuari(String usuari) {
		this.usuari = usuari;
	}

	public String getContrassenya() {
		return contrassenya;
	}

	public void setContrassenya(String contrassenya) {
		this.contrassenya = contrassenya;
	}

	public PerfilUsuari getPerfil() {
		return perfil;
	}

	public void setPerfil(PerfilUsuari perfil) {
		this.perfil = perfil;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getCognom1() {
		return cognom1;
	}

	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}

	public String getCognom2() {
		return cognom2;
	}

	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}


	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	@Override
	public String toString() {
		return "Usuari [id=" + id + ", usuari=" + usuari + ", contrassenya="
				+ contrassenya + ", perfil=" + perfil + ", nom=" + nom
				+ ", cognom1=" + cognom1 + ", cognom2=" + cognom2
				 + "]";
	}
	
	
	
	
	



}
