package com.andujar.springmvc.repository;

import java.util.Date;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;







import com.andujar.springmvc.domain.ActivitatAvaluadora;

@Repository
public class ActivitatAvaluadoraDAOHibernate implements ActivitatAvaluadoraDAO  {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAOi#guardaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAO#guardaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	@Override
	public long guardaActivitatAvaluadora(ActivitatAvaluadora activitatAvaluadora)
	{ 
			
	        return (Long)sf.getCurrentSession().save(activitatAvaluadora); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAOi#actualizaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAO#actualizaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	@Override
	public void actualizaActivitatAvaluadora(ActivitatAvaluadora activitatAvaluadora) 
	{ 
	     
	        sf.getCurrentSession().update(activitatAvaluadora);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAOi#eliminaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAO#eliminaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	@Override
	public void eliminaActivitatAvaluadora(ActivitatAvaluadora activitatAvaluadora) 
	{ 
	    
	       sf.getCurrentSession().delete(activitatAvaluadora);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAOi#obtenActivitatAvaluadora(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAO#obteActivitatAvaluadora(long)
	 */
	@Override
	public ActivitatAvaluadora obteActivitatAvaluadora(long idActivitatAvaluadora) 
	{ 
	        
	    return (ActivitatAvaluadora)sf.getCurrentSession().get(ActivitatAvaluadora.class, idActivitatAvaluadora); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAOi#obtenListaActivitatAvaluadoras()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ActivitatAvaluadoraDAO#obteLlistaActivitatAvaluadoras()
	 */
	@Override
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoras() throws HibernateException 
	{ 
	    List<ActivitatAvaluadora> listaActivitatAvaluadoras = null;  
	    
			listaActivitatAvaluadoras = sf.getCurrentSession().createQuery("from ActivitatAvaluadora").list(); 
	       
	     
	    return listaActivitatAvaluadoras; 
	}
	
	@Override
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadorasAlta(long unitatId) throws HibernateException 
	{ 
	    List<ActivitatAvaluadora> listaActivitatAvaluadoras = null;  
	    
			listaActivitatAvaluadoras = sf.getCurrentSession().createQuery("select distinct a from ActivitatAvaluadora a left join fetch a.areesActivitats where a.unitatDidactica.id = :unitatId and a.dataBaixa is null").
					setParameter ("unitatId", unitatId).list(); 
	     
	    return listaActivitatAvaluadoras; 
	}
	
	@Override
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoresAvaluacioAnyAcademic(long unitatId, Date fiAvaluacioAnyAcademic) 
	{ 
	    List<ActivitatAvaluadora> listaActivitatAvaluadoras = null;  
	    
	    //--seleccionar nom i id de les activitats d'una unitat didctica d'un nivell assignatura, tant d'alta com de baixa posterior al final del perode d'avaluaci
		//--select * from activitats_avaluadores act where  (act.data_baixa > '11/11/11' or act.data_baixa is null) and act.unitat_didactica_id = 2 ;
	    listaActivitatAvaluadoras = sf.getCurrentSession().createQuery(
	    		" from ActivitatAvaluadora as act where  (act.dataBaixa > :fiAvaluacioAnyAcademic or act.dataBaixa is null) and act.unitatDidactica.id = :unitatId")
					
					.setParameter("fiAvaluacioAnyAcademic", fiAvaluacioAnyAcademic)
					.setParameter ("unitatId", unitatId).list(); 
	    
	    return listaActivitatAvaluadoras; 
	}
	
	
	@Override
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoresPeriodeAvaluacio(long unitatId, Long periodeAvaluacio) 
	{ 
	    List<ActivitatAvaluadora> listaActivitatAvaluadoras = null;  
	    
	    //Seleccionar el nom de l'activitat avaluadora d'una unitat didctica a la que se li ha posat nota en un perode d'avaluacio concret
		/*
		select distinct aa.nom from activitats_avaluadores aa  join arees_activitats arees on aa.activitat_avaluadora_id = arees.activitat_avaluadora_id 
		              join qualificacions_arees_activitat qa on arees.area_activitat_id = qa.area_activitat_id
		              join periodes_avaluacions p on p.periode_avaluacio_id = qa.periode_avaluacio_id
		    where aa.unitat_didactica_id = 2 and p.avaluacio_any_academic_id = 1;
		*/
	    listaActivitatAvaluadoras = sf.getCurrentSession().createQuery(
	    		"select distinct act from QualificacioAreaActivitat as qa"
	    		+ " join qa.periodeAvaluacio as p"
	    		+ " join qa.areaActivitat as area"
	    		+ " join area.activitatAvaluadora act"
	    		+ " where act.unitatDidactica.id = :unitatId and p.id = :periodeAvaluacio"
	    		).setParameter("periodeAvaluacio", periodeAvaluacio)
				.setParameter ("unitatId", unitatId).list(); 
	    
	    
	 
	    return listaActivitatAvaluadoras; 
	}
	
	

}
