package com.andujar.springmvc.repository;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.andujar.springmvc.domain.*;

@Repository
public class AnyAcademicDAOHibernate implements AnyAcademicDAO {
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AnyAcademicDAOi#guardaAnyAcademic(com.andujar.springmvc.domain.AnyAcademic)
	 */
	@Override
	public long guardaAnyAcademic(AnyAcademic anyAcademic)
	{ 
			
	        return (Long)sf.getCurrentSession().save(anyAcademic); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AnyAcademicDAOi#actualizaAnyAcademic(com.andujar.springmvc.domain.AnyAcademic)
	 */
	@Override
	public void actualizaAnyAcademic(AnyAcademic anyAcademic) 
	{ 
	     
	        sf.getCurrentSession().update(anyAcademic);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AnyAcademicDAOi#eliminaAnyAcademic(com.andujar.springmvc.domain.AnyAcademic)
	 */
	@Override
	public void eliminaAnyAcademic(AnyAcademic anyAcademic) 
	{ 
	    System.out.println("AnyAcademicDAOHibernate esborra " +anyAcademic.getId());
	       sf.getCurrentSession().delete(anyAcademic);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AnyAcademicDAOi#obtenAnyAcademic(long)
	 */
	@Override
	public AnyAcademic obteAnyAcademic(long idAnyAcademic) 
	{ 
	        
	    return (AnyAcademic)sf.getCurrentSession().get(AnyAcademic.class, idAnyAcademic); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AnyAcademicDAOi#obtenListaAnyAcademics()
	 */
	@Override
	public List<AnyAcademic> obteLlistaAnyAcademics() throws HibernateException 
	{ 
	    List<AnyAcademic> listaAnyAcademics = null;  
	    
			listaAnyAcademics = sf.getCurrentSession().createQuery("from AnyAcademic").list(); 
	       
	     
	    return listaAnyAcademics; 
	}
	

}

