package com.andujar.springmvc.repository;




import java.util.List;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;




import com.andujar.springmvc.domain.AreaActivitat;

@Repository
public class AreaActivitatDAOHibernate implements AreaActivitatDAO  {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAOi#guardaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAO#guardaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	@Override
	public long guardaAreaActivitat(AreaActivitat areaActivitat)
	{ 
			
	        return (Long)sf.getCurrentSession().save(areaActivitat); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAOi#actualizaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAO#actualizaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	@Override
	public void actualizaAreaActivitat(AreaActivitat areaActivitat) 
	{ 
	     
	        sf.getCurrentSession().update(areaActivitat);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAOi#eliminaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAO#eliminaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	@Override
	public void eliminaAreaActivitat(AreaActivitat areaActivitat) 
	{ 
	    
	       sf.getCurrentSession().delete(areaActivitat);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAOi#obtenAreaActivitat(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAO#obteAreaActivitat(long)
	 */
	@Override
	public AreaActivitat obteAreaActivitat(long idAreaActivitat) 
	{ 
	        
	    return (AreaActivitat)sf.getCurrentSession().get(AreaActivitat.class, idAreaActivitat); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAOi#obtenListaAreaActivitats()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaActivitatDAO#obteLlistaAreaActivitats()
	 */
	@Override
	public List<AreaActivitat> obteLlistaAreaActivitats()  
	{ 
	    List<AreaActivitat> listaAreaActivitats = null;  
	    
			listaAreaActivitats = sf.getCurrentSession().createQuery("from AreaActivitat").list(); 
	       
	     
	    return listaAreaActivitats; 
	}
	
	@Override
	public List<AreaActivitat> obteLlistaAreaActivitatsActivitatAvaluadora(Long activitatAvalauadoraId) 
	{ 
	    List<AreaActivitat> listaAreaActivitats = null;  
	    
	    //--seleccionar totes les arees_activitat d'una activitat_id concreta
	    //SQL--select * from arees_activitats aa where aa.activitat_avaluadora_id = 1;
		
		listaAreaActivitats = sf.getCurrentSession().createQuery(
				"from AreaActivitat as a where a.activitatAvaluadora.id = :activitatAvalauadoraId")
				.setParameter("activitatAvalauadoraId", activitatAvalauadoraId)
				.list(); 
	       
	     
	    return listaAreaActivitats; 
	}
	
	@Override
	public List<AreaActivitat> obteLlistaAreaActivitatsAreaAssignatura(Long areaAssignaturaId) 
	{ 
	    List<AreaActivitat> listaAreaActivitats = null;  
	    
	    //--selecciona totes les AreaActivitats que corresponguin a una AreaAssignatura 
	  	//--select * from arees_activitats where area_assignatura_id = 1
	  		
		listaAreaActivitats = sf.getCurrentSession().createQuery(
				"from AreaActivitat as a where a.areaAssignatura.id = :areaAssignaturaId")
				.setParameter("areaAssignaturaId",areaAssignaturaId)
				.list(); 
	       
	     
	    return listaAreaActivitats; 
	}
	
	

}

