package com.andujar.springmvc.repository;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;





import com.andujar.springmvc.domain.AreaAssignatura;


@Repository
public class AreaAssignaturaDAOHibernate implements AreaAssignaturaDAO  {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAOi#guardaAreaAssignatura(com.andujar.springmvc.domain.AreaAssignatura)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAO#guardaAreaAssignatura(com.andujar.springmvc.domain.AreaAssignatura)
	 */
	@Override
	public long guardaAreaAssignatura(AreaAssignatura areaAssignatura)  
	{ 
	        return (Long)sf.getCurrentSession().save(areaAssignatura); 		    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAOi#actualizaAreaAssignatura(com.andujar.springmvc.domain.AreaAssignatura)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAO#actualizaAreaAssignatura(com.andujar.springmvc.domain.AreaAssignatura)
	 */
	@Override
	public void actualizaAreaAssignatura(AreaAssignatura areaAssignatura) 
	{ 
	     
	        sf.getCurrentSession().update(areaAssignatura);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAOi#eliminaAreaAssignatura(com.andujar.springmvc.domain.AreaAssignatura)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAO#eliminaAreaAssignatura(com.andujar.springmvc.domain.AreaAssignatura)
	 */
	@Override
	public void eliminaAreaAssignatura(AreaAssignatura areaAssignatura) 
	{ 
	    
	       sf.getCurrentSession().delete(areaAssignatura);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAOi#obtenAreaAssignatura(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAO#obteAreaAssignatura(long)
	 */
	@Override
	public AreaAssignatura obteAreaAssignatura(long idAreaAssignatura) 
	{ 
	        
	    return (AreaAssignatura)sf.getCurrentSession().get(AreaAssignatura.class, idAreaAssignatura); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAOi#obtenListaAreaAssignaturas()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AreaAssignaturaDAO#obteLlistaAreaAssignaturas()
	 */
	@Override
	public List<AreaAssignatura> obteLlistaAreaAssignaturas() throws HibernateException 
	{ 
	    List<AreaAssignatura> listaAreaAssignaturas = null;  
	    
			listaAreaAssignaturas = sf.getCurrentSession().createQuery("from AreaAssignatura").list(); 
	       
	     
	    return listaAreaAssignaturas; 
	}
	
	@Override
	public List<AreaAssignatura> obteLlistaAreaAssignaturasAlta() throws HibernateException 
	{ 
	    List<AreaAssignatura> listaAreaAssignaturas = null;  
	    
			listaAreaAssignaturas = sf.getCurrentSession().createQuery("from AreaAssignatura assignatura where assignatura.dataBaixa is null").list(); 
	       
	     
	    return listaAreaAssignaturas; 
	}
	
	public List<AreaAssignatura> obteLlistaAreaAssignaturasAltaNivell(long nivellId) 
	{ 
	    List<AreaAssignatura> listaAreaAssignaturas = null;  
	    
			listaAreaAssignaturas = sf.getCurrentSession().createQuery("from AreaAssignatura assignatura where assignatura.dataBaixa is null and assignatura.nivell.id = :nivellId").setParameter("nivellId", nivellId).list(); 
	       
	     
	    return listaAreaAssignaturas; 
	}
	
	


}
