package com.andujar.springmvc.repository;


import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.andujar.springmvc.domain.*;

@Repository
public class AssignaturaDAOHibernate implements AssignaturaDAO {
	
	@Autowired
	private SessionFactory sf; 
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AssignaturaDAO#guardaAssignatura(com.andujar.springmvc.domain.Assignatura)
	 */

	@Override
	public long guardaAssignatura(Assignatura assignatura)
	{ 
	    
	        return (Long)sf.getCurrentSession().save(assignatura); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AssignaturaDAO#actualizaAssignatura(com.andujar.springmvc.domain.Assignatura)
	 */

	@Override
	public void actualizaAssignatura(Assignatura assignatura) 
	{ 
	     
	        sf.getCurrentSession().update(assignatura); 
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AssignaturaDAO#eliminaAssignatura(com.andujar.springmvc.domain.Assignatura)
	 */
	
	@Override
	public void eliminaAssignatura(Assignatura assignatura) 
	{ 
	    
	        sf.getCurrentSession().delete(assignatura); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AssignaturaDAO#obteAssignatura(long)
	 */
	
	@Override
	public Assignatura obteAssignatura(long idAssignatura) 
	{ 
	     
	    return (Assignatura)sf.getCurrentSession().get(Assignatura.class, idAssignatura); 
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AssignaturaDAO#obteLlistaAssignaturas()
	 */
	
	@Override
	public List<Assignatura> obteLlistaAssignaturas() throws HibernateException 
	{ 
	    List<Assignatura> listaAssignaturas = null;  
	    
	    
	    
	        listaAssignaturas =  sf.getCurrentSession().createQuery("from Assignatura").list(); 
	   
	     
	    return listaAssignaturas; 
	}


}
