package com.andujar.springmvc.repository;



import java.util.Date;
import java.util.List;

import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.andujar.springmvc.domain.AvaluacioAnyAcademic;

@Repository
public class AvaluacioAnyAcademicDAOHibernate implements AvaluacioAnyAcademicDAO  {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAOi#guardaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAO#guardaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	@Override
	public long guardaAvaluacioAnyAcademic(AvaluacioAnyAcademic avaluacioAnyAcademic)
	{ 
			
	        return (Long)sf.getCurrentSession().save(avaluacioAnyAcademic); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAOi#actualizaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAO#actualizaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	@Override
	public void actualizaAvaluacioAnyAcademic(AvaluacioAnyAcademic avaluacioAnyAcademic) 
	{ 
	     
	        sf.getCurrentSession().update(avaluacioAnyAcademic);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAOi#eliminaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAO#eliminaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	@Override
	public void eliminaAvaluacioAnyAcademic(AvaluacioAnyAcademic avaluacioAnyAcademic) 
	{ 
	    
	       sf.getCurrentSession().delete(avaluacioAnyAcademic);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAOi#obtenAvaluacioAnyAcademic(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAO#obteAvaluacioAnyAcademic(long)
	 */
	@Override
	public AvaluacioAnyAcademic obteAvaluacioAnyAcademic(long idAvaluacioAnyAcademic) 
	{ 
	        
	    return (AvaluacioAnyAcademic)sf.getCurrentSession().get(AvaluacioAnyAcademic.class, idAvaluacioAnyAcademic); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAOi#obtenListaAvaluacioAnyAcademics()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.AvaluacioAnyAcademicDAO#obteLlistaAvaluacioAnyAcademics()
	 */
	@Override
	public List<AvaluacioAnyAcademic> obteLlistaAvaluacioAnyAcademics() 
	{ 
	    List<AvaluacioAnyAcademic> listaAvaluacioAnyAcademics = null;  
	    
			listaAvaluacioAnyAcademics = sf.getCurrentSession().createQuery("from AvaluacioAnyAcademic").list(); 
	       
	     
	    return listaAvaluacioAnyAcademics; 
	}
	
	@Override
	public List<AvaluacioAnyAcademic> obteLlistaAvaluacioAnyAcademics(Long anyId) 
	{ 
	    List<AvaluacioAnyAcademic> listaAvaluacioAnyAcademics = null;  
	    
			listaAvaluacioAnyAcademics = sf.getCurrentSession().createQuery("from AvaluacioAnyAcademic a where a.anyAcademic.id = :anyId ")
					.setParameter("anyId", anyId)
					.list(); 
	       
	     
	    return listaAvaluacioAnyAcademics; 
	}
	
	@Override
	public AvaluacioAnyAcademic obteCurrentAvaluacioAnyAcademics(Date date) 
	{ 
	    AvaluacioAnyAcademic avaluacioAnyAcademic = new AvaluacioAnyAcademic();
		
	    List<AvaluacioAnyAcademic> listaAvaluacioAnyAcademics = null; 
	    
	    // --a partir d'una data trobar la avalauacio_any_academic en curs
	    //--select * from avaluacions_any_academic a where a.data_inici <= sysdate and a.data_fi >= sysdate
		listaAvaluacioAnyAcademics = sf.getCurrentSession().createQuery("from AvaluacioAnyAcademic a where a.dataInici <= :date and a.dataFi >= :date")
					.setParameter("date", date).list();
		
		if (listaAvaluacioAnyAcademics.isEmpty()){
			return avaluacioAnyAcademic;
		}
	    
		avaluacioAnyAcademic = listaAvaluacioAnyAcademics.get(0);
	     
	    return avaluacioAnyAcademic; 
	}
	

}

