package com.andujar.springmvc.repository;




import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;




import com.andujar.springmvc.domain.Imparteix;

@Repository
public class ImparteixDAOHibernate implements ImparteixDAO  {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAOi#guardaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAO#guardaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	@Override
	public long guardaImparteix(Imparteix imparteix)
	{ 
			
	        return (Long)sf.getCurrentSession().save(imparteix); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAOi#actualizaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAO#actualizaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	@Override
	public void actualizaImparteix(Imparteix imparteix) 
	{ 
	     
	        sf.getCurrentSession().update(imparteix);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAOi#eliminaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAO#eliminaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	@Override
	public void eliminaImparteix(Imparteix imparteix) 
	{ 
	    
	       sf.getCurrentSession().delete(imparteix);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAOi#obtenImparteix(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAO#obteImparteix(long)
	 */
	@Override
	public Imparteix obteImparteix(long idImparteix) 
	{ 
	        
	    return (Imparteix)sf.getCurrentSession().get(Imparteix.class, idImparteix); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAOi#obtenListaImparteixs()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.ImparteixDAO#obteLlistaImparteixs()
	 */
	@Override
	public List<Imparteix> obteLlistaImparteixs() throws HibernateException 
	{ 
	    List<Imparteix> listaImparteixs = null;  
	    
			listaImparteixs = sf.getCurrentSession().createQuery("from Imparteix").list(); 
	       
	     
	    return listaImparteixs; 
	}
	

}
