package com.andujar.springmvc.repository;



import java.util.List;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;




import com.andujar.springmvc.domain.Matricula;

@Repository
public class MatriculaDAOHibernate implements MatriculaDAO  {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAOi#guardaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAO#guardaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	@Override
	public long guardaMatricula(Matricula matricula)
	{ 
			
	        return (Long)sf.getCurrentSession().save(matricula); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAOi#actualizaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAO#actualizaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	@Override
	public void actualizaMatricula(Matricula matricula) 
	{ 
	     
	        sf.getCurrentSession().update(matricula);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAOi#eliminaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAO#eliminaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	@Override
	public void eliminaMatricula(Matricula matricula) 
	{ 
	    
	       sf.getCurrentSession().delete(matricula);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAOi#obtenMatricula(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAO#obteMatricula(long)
	 */
	@Override
	public Matricula obteMatricula(long idMatricula) 
	{ 
	        
	    return (Matricula)sf.getCurrentSession().get(Matricula.class, idMatricula); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAOi#obtenListaMatriculas()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.MatriculaDAO#obteLlistaMatriculas()
	 */
	@Override
	public List<Matricula> obteLlistaMatriculas() 
	{ 
	    List<Matricula> listaMatriculas = null;  
	    
			listaMatriculas = sf.getCurrentSession().createQuery("from Matricula").list(); 
	       
	     
	    return listaMatriculas; 
	}
	
	@Override
	public Matricula obteMatricula(Long anyAcademicId, Long alumneId, Long nivellId)  
	{ 
		System.out.println("MatriculaDAO.obteMatricula(Long anyAcademicId, Long alumneId, Long nivellId):Matricula executant-se");
		System.out.println("MatriculaDAO.obteMatricula parmetres: anyAcademicId = "+anyAcademicId+" alumneId = "+alumneId+"nivellId = "+nivellId);
		List<Matricula> listaMatriculas = null;  
	    Matricula matricula;  
	    //System.out.println("matricula antes de query "+ matricula.toString());
	    
	    //--seleccionar matricula donada un any academic, alumne i nivell assignatura
	    //--select * from matricules m where m.any_academic_id = 1 and m.alumne_id = 1 and m.nivell_id = 1;
		listaMatriculas = sf.getCurrentSession().createQuery("from Matricula as m where m.anyAcademic.id = :anyAcademicId and m.alumne.id = :alumneId and m.nivell.id = :nivellId")
				.setParameter("nivellId", nivellId)
				.setParameter("alumneId", alumneId)
				.setParameter("anyAcademicId", anyAcademicId)
				.list(); 
		
		System.out.println("listaMatriculas = "+listaMatriculas.toString());
		System.out.println("Esta llena = "+ !listaMatriculas.isEmpty());
		if (!listaMatriculas.isEmpty()){
			System.out.println("entramos en if");
			matricula = listaMatriculas.get(0);
			System.out.println("Rtorna matricula "+ matricula.toString());
		    return matricula;
		}else{
			System.out.println("Rtorna null ");
			return null;
		}
	    
		
	}
	
	

}

