package com.andujar.springmvc.repository;

import java.util.List;

import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;


import com.andujar.springmvc.domain.Nivell;

@Repository
public class NivellDAOHibernate implements NivellDAO {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAOi#guardaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAO#guardaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	@Override
	public long guardaNivell(Nivell nivell)
	{ 
			
	        return (Long)sf.getCurrentSession().save(nivell); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAOi#actualizaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAO#actualizaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	@Override
	public void actualizaNivell(Nivell nivell) 
	{ 
	     
	        sf.getCurrentSession().update(nivell);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAOi#eliminaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAO#eliminaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	@Override
	public void eliminaNivell(Nivell nivell) 
	{ 
	    
	       sf.getCurrentSession().delete(nivell);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAOi#obtenNivell(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAO#obteNivell(long)
	 */
	@Override
	public Nivell obteNivell(long idNivell) 
	{ 
	        
	    return (Nivell)sf.getCurrentSession().get(Nivell.class, idNivell); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAOi#obtenListaNivells()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.NivellDAO#obteLlistaNivells()
	 */
	@Override
	public List<Nivell> obteLlistaNivells() 
	{ 
	    List<Nivell> listaNivells = null;  
	    
			listaNivells = sf.getCurrentSession().createQuery("from Nivell").list(); 
	       
	     
	    return listaNivells; 
	}
	
	@Override
	public List<Nivell> obteLlistaNivellsPerAssignatura(long assignaturaId) 
	{ 
	    List<Nivell> listaNivells = null;  
	    
			listaNivells = sf.getCurrentSession().
					createQuery("from Nivell nivell where nivell.assignatura.id = :assignaturaId")
					.setParameter("assignaturaId", assignaturaId) 
					.list(); 
	       
	     
	    return listaNivells; 
	}
	

}
