package com.andujar.springmvc.repository;



import java.util.List;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;







import com.andujar.springmvc.domain.Matricula;
import com.andujar.springmvc.domain.PeriodeAvaluacio;

@Repository
public class PeriodeAvaluacioDAOHibernate implements PeriodeAvaluacioDAO  {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAOi#guardaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAO#guardaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	@Override
	public long guardaPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio)
	{ 
			
	        return (Long)sf.getCurrentSession().save(periodeAvaluacio); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAOi#actualizaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAO#actualizaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	@Override
	public void actualizaPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio) 
	{ 
	     
	        sf.getCurrentSession().update(periodeAvaluacio);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAOi#eliminaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAO#eliminaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	@Override
	public void eliminaPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio) 
	{ 
	    
	       sf.getCurrentSession().delete(periodeAvaluacio);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAOi#obtenPeriodeAvaluacio(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAO#obtePeriodeAvaluacio(long)
	 */
	@Override
	public PeriodeAvaluacio obtePeriodeAvaluacio(long idPeriodeAvaluacio) 
	{ 
	        
	    return (PeriodeAvaluacio)sf.getCurrentSession().get(PeriodeAvaluacio.class, idPeriodeAvaluacio); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAOi#obtenListaPeriodeAvaluacios()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.PeriodeAvaluacioDAO#obteLlistaPeriodeAvaluacios()
	 */
	@Override
	public List<PeriodeAvaluacio> obteLlistaPeriodeAvaluacios() 
	{ 
	    List<PeriodeAvaluacio> listaPeriodeAvaluacios = null;  
	    
			listaPeriodeAvaluacios = sf.getCurrentSession().createQuery("from PeriodeAvaluacio").list(); 
	       
	     
	    return listaPeriodeAvaluacios; 
	}
	
	
	@Override
	public List<PeriodeAvaluacio> obteLlistaPeriodeAvaluacios(Long matriculaId, Long avaluacioAnyAcademic)
	{ 
	    List<PeriodeAvaluacio> listaPeriodeAvaluacios = null;  
	    //--selecciona el periode avaluacio donat una matricula i una avaluacio_any_academic
	    //--select * from periodes_avaluacions pa where pa.matricula_id = 1 and pa.avaluacio_any_academic_id = 1;
		
		listaPeriodeAvaluacios = sf.getCurrentSession().createQuery("from PeriodeAvaluacio as p where p.matricula.id = :matriculaId and p.avaluacioAnyAcademic.id = :avaluacioAnyAcademic")
				.setParameter("matriculaId", matriculaId)
				.setParameter("avaluacioAnyAcademic", avaluacioAnyAcademic)
				.list(); 
	       
	     
	    return listaPeriodeAvaluacios; 
	}
	
	@Override
	public PeriodeAvaluacio obtePeriodeAvaluacio(Matricula matricula, Long avaluacioAnyAcademic)
	{ 
	    List<PeriodeAvaluacio> listaPeriodeAvaluacios = null;  
	    PeriodeAvaluacio p = new PeriodeAvaluacio();
	    
	    System.out.println ("PeriodeAvaluacioDAO.obtePeriodeAvaluacio executant-se");
	    
	    //System.out.println ("PeriodeAvaluacioDAO parmetre matricula =  "+matricula.toString());
	    if (matricula == null){
	    	System.out.println ("obtePeriodeAvaluacios retorna null");
	    	return p;
	    }
	    
	    
	    Long matriculaId = matricula.getId();
	    System.out.println ("PeriodeAvaluacioDAO long recuperat matriculaId =  "+matriculaId);
	    System.out.println("PeriodeAvaluacioDAO parametre avaluacioAnyAcademic = "+avaluacioAnyAcademic);
	    
	    
	    //--selecciona el periode avaluacio donat una matricula i una avaluacio_any_academic
	    //--select * from periodes_avaluacions pa where pa.matricula_id = 1 and pa.avaluacio_any_academic_id = 1;
		listaPeriodeAvaluacios = sf.getCurrentSession().createQuery("from PeriodeAvaluacio as p where p.matricula.id = :matriculaId and p.avaluacioAnyAcademic.id = :avaluacioAnyAcademic")
				.setParameter("matriculaId", matriculaId)
				.setParameter("avaluacioAnyAcademic", avaluacioAnyAcademic)
				.list(); 
	     
		
		//System.out.println("listaPeriodesAvaluacio = "+listaPeriodeAvaluacios.toString());
		System.out.println("Esta llena = "+ !listaPeriodeAvaluacios.isEmpty());
		if (!listaPeriodeAvaluacios.isEmpty()){
			System.out.println("entramos en if");
			p = listaPeriodeAvaluacios.get(0);
			System.out.println("Rtorna periode ");
		    return p;
		}else{
			System.out.println("Rtorna null ");
			return p;
		}
	     
	    
	}
	

}
