package com.andujar.springmvc.repository;


import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;




import com.andujar.springmvc.domain.QualificacioArea;

@Repository
public class QualificacioAreaDAOHibernate implements QualificacioAreaDAO {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAOi#guardaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAO#guardaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	@Override
	public long guardaQualificacioArea(QualificacioArea qualificacioArea)
	{ 
			
	        return (Long)sf.getCurrentSession().save(qualificacioArea); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAOi#actualizaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAO#actualizaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	@Override
	public void actualizaQualificacioArea(QualificacioArea qualificacioArea) 
	{ 
	     
	        sf.getCurrentSession().update(qualificacioArea);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAOi#eliminaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAO#eliminaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	@Override
	public void eliminaQualificacioArea(QualificacioArea qualificacioArea) 
	{ 
	    
	       sf.getCurrentSession().delete(qualificacioArea);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAOi#obtenQualificacioArea(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAO#obteQualificacioArea(long)
	 */
	@Override
	public QualificacioArea obteQualificacioArea(long idQualificacioArea) 
	{ 
	        
	    return (QualificacioArea)sf.getCurrentSession().get(QualificacioArea.class, idQualificacioArea); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAOi#obtenListaQualificacioAreas()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.QualificacioAreaDAO#obteLlistaQualificacioAreas()
	 */
	@Override
	public List<QualificacioArea> obteLlistaQualificacioAreas() throws HibernateException 
	{ 
	    List<QualificacioArea> listaQualificacioAreas = null;  
	    
			listaQualificacioAreas = sf.getCurrentSession().createQuery("from QualificacioArea").list(); 
	       
	     
	    return listaQualificacioAreas; 
	}
	
	@Override
	public List<QualificacioArea> obteLlistaQualificacioAreasPeriode(Long periodeAvaluacioId)
	{ 
	    List<QualificacioArea> listaQualificacioAreas = null;  
	    
			listaQualificacioAreas = sf.getCurrentSession().createQuery("from QualificacioArea q where q.periodeAvaluacio.id = :periodeAvaluacioId")
					.setParameter("periodeAvaluacioId", periodeAvaluacioId)
					.list(); 
	       
	     
	    return listaQualificacioAreas; 
	}

}
