package com.andujar.springmvc.repository;

import java.util.Date;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;





import com.andujar.springmvc.domain.UnitatDidactica;

@Repository
public class UnitatDidacticaDAOHibernate implements UnitatDidacticaDAO {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAOi#guardaUnitatDidactica(com.andujar.springmvc.domain.UnitatDidactica)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAO#guardaUnitatDidactica(com.andujar.springmvc.domain.UnitatDidactica)
	 */
	@Override
	public long guardaUnitatDidactica(UnitatDidactica unitatDidactica)
	{ 
			
	        return (Long)sf.getCurrentSession().save(unitatDidactica); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAOi#actualizaUnitatDidactica(com.andujar.springmvc.domain.UnitatDidactica)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAO#actualizaUnitatDidactica(com.andujar.springmvc.domain.UnitatDidactica)
	 */
	@Override
	public void actualizaUnitatDidactica(UnitatDidactica unitatDidactica) 
	{ 
	     
	        sf.getCurrentSession().update(unitatDidactica);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAOi#eliminaUnitatDidactica(com.andujar.springmvc.domain.UnitatDidactica)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAO#eliminaUnitatDidactica(com.andujar.springmvc.domain.UnitatDidactica)
	 */
	@Override
	public void eliminaUnitatDidactica(UnitatDidactica unitatDidactica) 
	{ 
	    
	       sf.getCurrentSession().delete(unitatDidactica);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAOi#obtenUnitatDidactica(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAO#obteUnitatDidactica(long)
	 */
	@Override
	public UnitatDidactica obteUnitatDidactica(long idUnitatDidactica) 
	{ 
	        
	    return (UnitatDidactica)sf.getCurrentSession().get(UnitatDidactica.class, idUnitatDidactica); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAOi#obtenListaUnitatDidacticas()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UnitatDidacticaDAO#obteLlistaUnitatDidacticas()
	 */
	@Override
	public List<UnitatDidactica> obteLlistaUnitatDidacticas() throws HibernateException 
	{ 
	    List<UnitatDidactica> listaUnitatDidacticas = null;  
	    
			listaUnitatDidacticas = sf.getCurrentSession().createQuery("from UnitatDidactica").list(); 
	       
	     
	    return listaUnitatDidacticas; 
	}
	
	@Override
	public List<UnitatDidactica> obteLlistaUnitatDidacticasAlta(long nivellId)
	{ 
	    List<UnitatDidactica> listaUnitatDidacticas = null;  
	    
			listaUnitatDidacticas = sf.getCurrentSession().createQuery("from UnitatDidactica u where u.nivell.id = :nivellId and u.dataBaixa is null")
					.setParameter("nivellId", nivellId)
					.list(); 
	     
	    return listaUnitatDidacticas; 
	}
	
	@Override
	public List<UnitatDidactica> obteLlistaUnitatDidacticasAltaAvaluacio(long nivellId, Date fiAvaluacioAnyAcademic) 
	{ 
	    List<UnitatDidactica> listaUnitatDidacticas = null;  
	    
	    //unitats didctiques donat un nivell_id que estiguin d'alta durant avaluacio_any_academic (data_baixa null o posterior a avaluacio_any_academic.data_fi)
	    //SQL --select * from unitats_didactiques u where u.nivell_id = 1 and (u.data_baixa is null or u.data_baixa > '11/11/11');	
	    listaUnitatDidacticas = sf.getCurrentSession().createQuery("from UnitatDidactica u where u.nivell.id = :nivellId and (u.dataBaixa is null or u.dataBaixa > :fiAvaluacioAnyAcademic)")
	    		
	    		
	    		.setParameter("nivellId", nivellId)
	    		.setDate("fiAvaluacioAnyAcademic", fiAvaluacioAnyAcademic)
					.list(); 
	     
	    return listaUnitatDidacticas; 
	}
	
	
	
	

}
