package com.andujar.springmvc.repository;


import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;







import com.andujar.springmvc.domain.PerfilUsuari;
import com.andujar.springmvc.domain.Usuari;

@Repository
public class UsuariDAOHibernate implements UsuariDAO  {
	
	
	@Autowired
	private SessionFactory sf; 
	
	
	private PerfilUsuari perfil;
	
	
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAOi#guardaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAO#guardaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	@Override
	public long guardaUsuari(Usuari usuari)
	{ 
			
	        return (Long)sf.getCurrentSession().save(usuari); 
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAOi#actualizaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAO#actualizaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	@Override
	public void actualizaUsuari(Usuari usuari) 
	{ 
	     
	        sf.getCurrentSession().update(usuari);
	        	
	     
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAOi#eliminaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAO#eliminaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	@Override
	public void eliminaUsuari(Usuari usuari) 
	{ 
	    
	       sf.getCurrentSession().delete(usuari);
			
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAOi#obtenUsuari(long)
	 */

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAO#obteUsuari(long)
	 */
	@Override
	public Usuari obteUsuari(long idUsuari) 
	{ 
	        
	    return (Usuari)sf.getCurrentSession().get(Usuari.class, idUsuari); 
	    
	    
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAOi#obtenListaUsuaris()
	 */
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.repository.UsuariDAO#obteLlistaUsuaris()
	 */
	@Override
	public List<Usuari> obteLlistaUsuaris() throws HibernateException 
	{ 
	    List<Usuari> listaUsuaris = null;  
	    
			listaUsuaris = sf.getCurrentSession().createQuery("from Usuari").list(); 
	       
	     
	    return listaUsuaris; 
	}
	
	@Override
	public List<Usuari> obteLlistaAlumnes() throws HibernateException 
	{ 
	    List<Usuari> listaUsuaris = null;  
	    
			listaUsuaris = sf.getCurrentSession().createQuery("from Usuari u where u.perfil = '"+ perfil.ALUMNE+"'").list(); 
	       
	     
	    return listaUsuaris; 
	}

	
	@Override
	public List<Usuari> obteLlistaProfessors() throws HibernateException 
	{ 
	    List<Usuari> listaUsuaris = null;  
	    
			listaUsuaris = sf.getCurrentSession().createQuery("from Usuari u where u.perfil = '"+ perfil.PROFESSOR+"'").list(); 
	       
	     
	    return listaUsuaris; 
	}
	
	
	@Override
	public List<Usuari> obteLlistaAdministradors() throws HibernateException 
	{ 
	    List<Usuari> listaUsuaris = null;  
	    
			listaUsuaris = sf.getCurrentSession().createQuery("from Usuari u where u.perfil = '"+ perfil.ADMINISTRADOR+"'").list(); 
	       
	     
	    return listaUsuaris; 
	}
	
	
	@Override
	public List<Usuari> obteLlistaPares() throws HibernateException 
	{ 
	    List<Usuari> listaUsuaris = null;  
	    
			listaUsuaris = sf.getCurrentSession().createQuery("from Usuari u where u.perfil = '"+ perfil.PARE+"'").list(); 
	       
	     
	    return listaUsuaris; 
	}
	
	
	
	@Override
	public List<Usuari> obteLlistaAlumnesMatriculats(Long anyAcademicId, Long nivellId) 
	{ 
		System.out.println("UsuariDAO.obteLlistaAlumnesMatriculats executant-se");
		System.out.println("UsuariDAO.obteLlistaAlumnesMatriculats parmetres: anyId = "+anyAcademicId+" nivellId = "+nivellId);
	    List<Usuari> listaUsuaris = null;  
	    
	  //--seleccionar tots els alumnes matriculats en un nivell asignatura un any acadmic concret. Es pot ampliar que noms surtin els alumnes del professor que ha iniciat sessi
		//SQL --select *from usuaris u join matricules m on  m.alumne_id = u.usuari_id where m.any_academic_id = 1 and m.nivell_id = 1;
		listaUsuaris = sf.getCurrentSession().createQuery(
			"select a from Matricula as m join m.alumne as a where m.anyAcademic.id = :anyAcademicId and m.nivell.id = :nivellId")
			.setParameter("anyAcademicId", anyAcademicId)
			.setParameter("nivellId", nivellId)
			.list(); 
	
		System.out.println("UsuariDAO listaUsuaris "+listaUsuaris.toString());
	    return listaUsuaris; 
	}
	
	
	//--seleccionar tots els alumnes matriculats en un nivell asignatura un any acadmic concret. Es pot ampliar que noms surtin els alumnes del professor que ha iniciat sessi
	//--select *from usuaris u join matricules m on  m.alumne_id = u.usuari_id where m.any_academic_id = 1 and m.nivell_id = 1;

	
	
	
	

}
