package com.andujar.springmvc.service;

import java.util.Date;
import java.util.List;

import com.andujar.springmvc.domain.ActivitatAvaluadora;
import com.andujar.springmvc.domain.UnitatDidactica;
import com.andujar.springmvc.exception.Excepcio;

public interface ActivitatAvaluadoraService {

	public abstract long guardaActivitatAvaluadora(
			ActivitatAvaluadora activitatAvaluadora);

	public abstract long guardaActivitatAvaluadora(
			UnitatDidactica unitatDidactica, String nom, Date dataAlta,
			Date dataBaixa) throws Excepcio;

	public abstract void actualizaActivitatAvaluadora(
			ActivitatAvaluadora activitatAvaluadora);

	public abstract void eliminaActivitatAvaluadora(
			ActivitatAvaluadora activitatAvaluadora);

	public abstract ActivitatAvaluadora obteActivitatAvaluadora(
			long idActivitatAvaluadora);

	public abstract List<ActivitatAvaluadora> obteLlistaActivitatAvaluadora();
	
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoraAlta(long unitatId);
	
	public void donaBaixaActivitatAvaluadora (long activitatAvaluadoraId);
	
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoresAvaluacioAnyAcademic(long unitatId, Date fiAvaluacioAnyAcademic);

	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoresPeriodeAvaluacio(long unitatId, Long periodeAvaluacio);
	
	public boolean percentatgesComplet (List <String> percentatges);
}