package com.andujar.springmvc.service;




import java.util.Date;
import java.util.List;
import java.util.Iterator;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.ActivitatAvaluadora;
import com.andujar.springmvc.domain.UnitatDidactica;
import com.andujar.springmvc.exception.Excepcio;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class ActivitatAvaluadoraServiceImpl implements ActivitatAvaluadoraService  {
	
	ActivitatAvaluadora activitatAvaluadoraClass;

	@Autowired
	private ActivitatAvaluadoraDAO dao;
	

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActivitatAvaluadoraService#guardaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	@Override
	public long guardaActivitatAvaluadora(ActivitatAvaluadora activitatAvaluadora){
		return dao.guardaActivitatAvaluadora  (activitatAvaluadora);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActivitatAvaluadoraService#guardaActivitatAvaluadora(com.andujar.springmvc.domain.UnitatDidactica, java.lang.String, java.util.Date, java.util.Date)
	 */
	@Override
	public long guardaActivitatAvaluadora(UnitatDidactica unitatDidactica, String nom,
			Date dataAlta, Date dataBaixa) throws Excepcio {
		activitatAvaluadoraClass = new ActivitatAvaluadora(unitatDidactica,  nom,
				dataAlta, dataBaixa);
		return dao.guardaActivitatAvaluadora  (activitatAvaluadoraClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActivitatAvaluadoraService#actualizaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	@Override
	public void actualizaActivitatAvaluadora(ActivitatAvaluadora activitatAvaluadora){
		dao.actualizaActivitatAvaluadora(activitatAvaluadora);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActivitatAvaluadoraService#eliminaActivitatAvaluadora(com.andujar.springmvc.domain.ActivitatAvaluadora)
	 */
	@Override
	public void eliminaActivitatAvaluadora(ActivitatAvaluadora activitatAvaluadora){
		dao.eliminaActivitatAvaluadora(activitatAvaluadora);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActivitatAvaluadoraService#obteActivitatAvaluadora(long)
	 */
	@Override
	public ActivitatAvaluadora obteActivitatAvaluadora(long idActivitatAvaluadora) {
		return dao.obteActivitatAvaluadora(idActivitatAvaluadora);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActivitatAvaluadoraService#obteLlistaActivitatAvaluadora()
	 */
	@Override
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadora(){
		
		return dao.obteLlistaActivitatAvaluadoras();
	}
	
	@Override
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoraAlta(long unitatId){
		
		return dao.obteLlistaActivitatAvaluadorasAlta(unitatId);
	}
	
	@Override
	public void donaBaixaActivitatAvaluadora (long activitatAvaluadoraId){
		activitatAvaluadoraClass = obteActivitatAvaluadora(activitatAvaluadoraId);
		activitatAvaluadoraClass.setDataBaixa(new Date());
		actualizaActivitatAvaluadora(activitatAvaluadoraClass);
	}
	
	@Override
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoresAvaluacioAnyAcademic(long unitatId, Date fiAvaluacioAnyAcademic){
		return dao.obteLlistaActivitatAvaluadoresAvaluacioAnyAcademic(unitatId, fiAvaluacioAnyAcademic);
	}
	
	@Override
	public List<ActivitatAvaluadora> obteLlistaActivitatAvaluadoresPeriodeAvaluacio(long unitatId, Long periodeAvaluacio){
		
		return dao.obteLlistaActivitatAvaluadoresPeriodeAvaluacio(unitatId, periodeAvaluacio);
	}
	
	
	@Override
	public boolean percentatgesComplet (List <String> percentatges)
	{
		
		boolean complet = false;
		double total = 0;
		String percentatgeStr;
		
		Iterator <String> it = percentatges.iterator();
		while (it.hasNext()){
			
			percentatgeStr = it.next();
			System.out.println("ActivitatAvaluadoraService.percentatgesComplet. Percentatge "+percentatgeStr);
			if (percentatgeStr != "")
			total = total + Double.parseDouble(percentatgeStr);
			
		}
		
		if (total == 100){
			complet = true;
		}
		
		return complet;
	}

}

