package com.andujar.springmvc.service;


import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.ActivitatAvaluadora;
import com.andujar.springmvc.domain.AreaActivitat;
import com.andujar.springmvc.domain.AreaAssignatura;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class AreaActivitatServiceImpl implements AreaActivitatService  {
	
	AreaActivitat areaActivitatClass;

	@Autowired
	private AreaActivitatDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AreaActivitatService#guardaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	@Override
	public long guardaAreaActivitat(AreaActivitat areaActivitat){
		return dao.guardaAreaActivitat  (areaActivitat);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AreaActivitatService#guardaAreaActivitat(com.andujar.springmvc.domain.AreaAssignatura, com.andujar.springmvc.domain.ActivitatAvaluadora, double)
	 */
	@Override
	public long guardaAreaActivitat(AreaAssignatura areaAssignatura,
			ActivitatAvaluadora activitatAvaluadora,
			double percentatgeProgramacio){
		areaActivitatClass = new AreaActivitat( areaAssignatura,
				 activitatAvaluadora,
				percentatgeProgramacio);
		return dao.guardaAreaActivitat  (areaActivitatClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AreaActivitatService#actualizaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	@Override
	public void actualizaAreaActivitat(AreaActivitat areaActivitat){
		dao.actualizaAreaActivitat(areaActivitat);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AreaActivitatService#eliminaAreaActivitat(com.andujar.springmvc.domain.AreaActivitat)
	 */
	@Override
	public void eliminaAreaActivitat(AreaActivitat areaActivitat){
		dao.eliminaAreaActivitat(areaActivitat);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AreaActivitatService#obteAreaActivitat(long)
	 */
	@Override
	public AreaActivitat obteAreaActivitat(long idAreaActivitat) {
		return dao.obteAreaActivitat(idAreaActivitat);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AreaActivitatService#obteLlistaAreaActivitat()
	 */
	@Override
	public List<AreaActivitat> obteLlistaAreaActivitat(){
		
		return dao.obteLlistaAreaActivitats();
	}
	
	@Override
	public List<AreaActivitat> obteLlistaAreaActivitatsActivitatAvaluadora(Long activitatAvalauadoraId){
		
		return dao.obteLlistaAreaActivitatsActivitatAvaluadora(activitatAvalauadoraId);
	}
	
	@Override
	public List<AreaActivitat> obteLlistaAreaActivitatsAreaAssignatura(Long areaAssignaturaId)
	{
		return dao.obteLlistaAreaActivitatsAreaAssignatura(areaAssignaturaId);
	}
	
	

}

