package com.andujar.springmvc.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;


import com.andujar.springmvc.domain.Assignatura;
import com.andujar.springmvc.repository.AssignaturaDAO;



@Component
@Transactional
public class AssignaturaServiceImpl implements AssignaturaService {
	
	Assignatura assignaturaClass;
	
	@Autowired
	private AssignaturaDAO dao;
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AssignaturaService#guardaAssignatura(com.andujar.springmvc.domain.Assignatura)
	 */
	@Override
	public long guardaAssignatura(Assignatura assignatura){
		return dao.guardaAssignatura  (assignatura);
	}

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AssignaturaService#guardaAssignatura(java.lang.String)
	 */
	@Override
	public long guardaAssignatura(String assignatura){
		assignaturaClass = new Assignatura(assignatura);
		return dao.guardaAssignatura  (assignaturaClass);
	}

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AssignaturaService#actualizaAssignatura(com.andujar.springmvc.domain.Assignatura)
	 */
	
	@Override
	public void actualizaAssignatura(Assignatura assignatura){
		dao.actualizaAssignatura(assignatura);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AssignaturaService#eliminaAssignatura(com.andujar.springmvc.domain.Assignatura)
	 */
	
	@Override
	public void eliminaAssignatura(Assignatura assignatura){
		dao.eliminaAssignatura(assignatura);
	}
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AssignaturaService#obteAssignatura(long)
	 */
	
	@Override
	public Assignatura obteAssignatura(long idAssignatura) {
		return dao.obteAssignatura(idAssignatura);
	}
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AssignaturaService#obteLlistaAssignatura()
	 */
	
	@Override
	public List<Assignatura> obteLlistaAssignatura(){
		
		return dao.obteLlistaAssignaturas();
	}
	
	

}
