package com.andujar.springmvc.service;


import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.AvaluacioAnyAcademic;
import com.andujar.springmvc.domain.Avaluacions;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class AvaluacioAnyAcademicServiceImpl implements AvaluacioAnyAcademicService  {
	
	AvaluacioAnyAcademic avaluacioAnyAcademicClass;

	@Autowired
	private AvaluacioAnyAcademicDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AvaluacioAnyAcademicService#guardaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	@Override
	public long guardaAvaluacioAnyAcademic(AvaluacioAnyAcademic avaluacioAnyAcademic){
		return dao.guardaAvaluacioAnyAcademic  (avaluacioAnyAcademic);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AvaluacioAnyAcademicService#guardaAvaluacioAnyAcademic(java.lang.String, java.util.Date, java.util.Date)
	 */
	@Override
	public long guardaAvaluacioAnyAcademic (Avaluacions nom, Date dataInici, Date datFi){
		avaluacioAnyAcademicClass = new AvaluacioAnyAcademic (nom, dataInici, datFi);
		return dao.guardaAvaluacioAnyAcademic  (avaluacioAnyAcademicClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AvaluacioAnyAcademicService#actualizaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	@Override
	public void actualizaAvaluacioAnyAcademic(AvaluacioAnyAcademic avaluacioAnyAcademic){
		dao.actualizaAvaluacioAnyAcademic(avaluacioAnyAcademic);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AvaluacioAnyAcademicService#eliminaAvaluacioAnyAcademic(com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	@Override
	public void eliminaAvaluacioAnyAcademic(AvaluacioAnyAcademic avaluacioAnyAcademic){
		dao.eliminaAvaluacioAnyAcademic(avaluacioAnyAcademic);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AvaluacioAnyAcademicService#obteAvaluacioAnyAcademic(long)
	 */
	@Override
	public AvaluacioAnyAcademic obteAvaluacioAnyAcademic(long idAvaluacioAnyAcademic) {
		return dao.obteAvaluacioAnyAcademic(idAvaluacioAnyAcademic);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.AvaluacioAnyAcademicService#obteLlistaAvaluacioAnyAcademic()
	 */
	@Override
	public List<AvaluacioAnyAcademic> obteLlistaAvaluacioAnyAcademic(){
		
		return dao.obteLlistaAvaluacioAnyAcademics();
	}
	
	@Override
	public List<AvaluacioAnyAcademic> obteLlistaAvaluacioAnyAcademic(Long anyId){
		
		return dao.obteLlistaAvaluacioAnyAcademics(anyId);
	}
	
	@Override
	public AvaluacioAnyAcademic obteCurrentAvaluacioAnyAcademics(Date date)
	{
		return dao.obteCurrentAvaluacioAnyAcademics(date);
	}
	
	

}
