package com.andujar.springmvc.service;



import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.Butlleti;
import com.andujar.springmvc.domain.PeriodeAvaluacio;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class ButlletiServiceImpl implements ButlletiService  {
	
	Butlleti butlletiClass;

	@Autowired
	private ButlletiDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ButlletiService#guardaButlleti(com.andujar.springmvc.domain.Butlleti)
	 */
	@Override
	public long guardaButlleti(Butlleti butlleti){
		return dao.guardaButlleti  (butlleti);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ButlletiService#guardaButlleti(com.andujar.springmvc.domain.PeriodeAvaluacio, int, int, java.lang.String, int, java.lang.Double, int)
	 */
	@Override
	public long guardaButlleti(PeriodeAvaluacio periodeAvaluacio, int faltesJustificades,
			int faltesInjustificades, String comentari, int promociona,
			Double notaGlobal, int publicat){
		butlletiClass = new Butlleti(periodeAvaluacio, faltesJustificades,
				faltesInjustificades, comentari, promociona,
				notaGlobal, publicat);
		return dao.guardaButlleti  (butlletiClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ButlletiService#actualizaButlleti(com.andujar.springmvc.domain.Butlleti)
	 */
	@Override
	public void actualizaButlleti(Butlleti butlleti){
		dao.actualizaButlleti(butlleti);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ButlletiService#eliminaButlleti(com.andujar.springmvc.domain.Butlleti)
	 */
	@Override
	public void eliminaButlleti(Butlleti butlleti){
		dao.eliminaButlleti(butlleti);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ButlletiService#obteButlleti(long)
	 */
	@Override
	public Butlleti obteButlleti(long idButlleti) {
		return dao.obteButlleti(idButlleti);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ButlletiService#obteLlistaButlleti()
	 */
	@Override
	public List<Butlleti> obteLlistaButlleti(){
		
		return dao.obteLlistaButlletis();
	}
	
	

}

