package com.andujar.springmvc.service;


import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.Assignatura;
import com.andujar.springmvc.domain.Imparteix;
import com.andujar.springmvc.domain.Usuari;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class ImparteixServiceImpl implements ImparteixService  {
	
	Imparteix imparteixClass;

	@Autowired
	private ImparteixDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ImparteixService#guardaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	@Override
	public long guardaImparteix(Imparteix imparteix){
		return dao.guardaImparteix  (imparteix);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ImparteixService#guardaImparteix(com.andujar.springmvc.domain.Usuari, java.util.List)
	 */
	@Override
	public long guardaImparteix (Usuari professor, List<Assignatura> assignatures){
		imparteixClass = new Imparteix (professor, assignatures);
		return dao.guardaImparteix  (imparteixClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ImparteixService#actualizaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	@Override
	public void actualizaImparteix(Imparteix imparteix){
		dao.actualizaImparteix(imparteix);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ImparteixService#eliminaImparteix(com.andujar.springmvc.domain.Imparteix)
	 */
	@Override
	public void eliminaImparteix(Imparteix imparteix){
		dao.eliminaImparteix(imparteix);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ImparteixService#obteImparteix(long)
	 */
	@Override
	public Imparteix obteImparteix(long idImparteix) {
		return dao.obteImparteix(idImparteix);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ImparteixService#obteLlistaImparteix()
	 */
	@Override
	public List<Imparteix> obteLlistaImparteix(){
		
		return dao.obteLlistaImparteixs();
	}
	
	

}

