package com.andujar.springmvc.service;




import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.AnyAcademic;
import com.andujar.springmvc.domain.Matricula;
import com.andujar.springmvc.domain.Nivell;
import com.andujar.springmvc.domain.Usuari;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class MatriculaServiceImpl implements MatriculaService  {
	
	Matricula matriculaClass;

	@Autowired
	private MatriculaDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MatriculaService#guardaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	@Override
	public long guardaMatricula(Matricula matricula){
		return dao.guardaMatricula  (matricula);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MatriculaService#guardaMatricula(com.andujar.springmvc.domain.Usuari, com.andujar.springmvc.domain.Usuari, com.andujar.springmvc.domain.AnyAcademic, com.andujar.springmvc.domain.Nivell)
	 */
	@Override
	public long guardaMatricula(Usuari alumne, Usuari professor, AnyAcademic anyAcademic,
			Nivell nivell){
		matriculaClass = new Matricula(alumne, professor, anyAcademic,
				nivell);
		return dao.guardaMatricula  (matriculaClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MatriculaService#actualizaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	@Override
	public void actualizaMatricula(Matricula matricula){
		dao.actualizaMatricula(matricula);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MatriculaService#eliminaMatricula(com.andujar.springmvc.domain.Matricula)
	 */
	@Override
	public void eliminaMatricula(Matricula matricula){
		dao.eliminaMatricula(matricula);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MatriculaService#obteMatricula(long)
	 */
	@Override
	public Matricula obteMatricula(long idMatricula) {
		return dao.obteMatricula(idMatricula);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MatriculaService#obteLlistaMatricula()
	 */
	@Override
	public List<Matricula> obteLlistaMatricula(){
		
		return dao.obteLlistaMatriculas();
	}
	
	@Override
	public Matricula obteMatricula(Long anyAcademicId, Long alumneId, Long nivellId)  
	{
		 
		return dao.obteMatricula(anyAcademicId, alumneId, nivellId);
	}
	
	

}
