package com.andujar.springmvc.service;


import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.Butlleti;
import com.andujar.springmvc.domain.MitjaAreaButlleti;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class MitjaAreaButlletiServiceImpl implements MitjaAreaButlletiService  {
	
	MitjaAreaButlleti mitjaAreaButlletiClass;

	@Autowired
	private MitjaAreaButlletiDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MitjaAreaButlletiService#guardaMitjaAreaButlleti(com.andujar.springmvc.domain.MitjaAreaButlleti)
	 */
	@Override
	public long guardaMitjaAreaButlleti(MitjaAreaButlleti mitjaAreaButlleti){
		return dao.guardaMitjaAreaButlleti  (mitjaAreaButlleti);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MitjaAreaButlletiService#guardaMitjaAreaButlleti(com.andujar.springmvc.domain.Butlleti, java.lang.Double, java.lang.Double)
	 */
	@Override
	public long guardaMitjaAreaButlleti(Butlleti butlleti, Double mitja,
			Double ponderacioGlobal){
		mitjaAreaButlletiClass = new MitjaAreaButlleti(butlleti, mitja,
				ponderacioGlobal);
		return dao.guardaMitjaAreaButlleti  (mitjaAreaButlletiClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MitjaAreaButlletiService#actualizaMitjaAreaButlleti(com.andujar.springmvc.domain.MitjaAreaButlleti)
	 */
	@Override
	public void actualizaMitjaAreaButlleti(MitjaAreaButlleti mitjaAreaButlleti){
		dao.actualizaMitjaAreaButlleti(mitjaAreaButlleti);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MitjaAreaButlletiService#eliminaMitjaAreaButlleti(com.andujar.springmvc.domain.MitjaAreaButlleti)
	 */
	@Override
	public void eliminaMitjaAreaButlleti(MitjaAreaButlleti mitjaAreaButlleti){
		dao.eliminaMitjaAreaButlleti(mitjaAreaButlleti);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MitjaAreaButlletiService#obteMitjaAreaButlleti(long)
	 */
	@Override
	public MitjaAreaButlleti obteMitjaAreaButlleti(long idMitjaAreaButlleti) {
		return dao.obteMitjaAreaButlleti(idMitjaAreaButlleti);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.MitjaAreaButlletiService#obteLlistaMitjaAreaButlleti()
	 */
	@Override
	public List<MitjaAreaButlleti> obteLlistaMitjaAreaButlleti(){
		
		return dao.obteLlistaMitjaAreaButlletis();
	}
	
	

}

