package com.andujar.springmvc.service;



import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.Assignatura;
import com.andujar.springmvc.domain.Nivell;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class NivellServiceImpl implements NivellService {
	
	Nivell nivellClass;

	@Autowired
	private NivellDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NivellService#guardaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	@Override
	public long guardaNivell(Nivell nivell){
		return dao.guardaNivell  (nivell);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NivellService#guardaNivell(java.lang.String)
	 */
	@Override
	public long guardaNivell(Assignatura assignatura,String nivell){
		nivellClass = new Nivell(assignatura, nivell);
		return dao.guardaNivell  (nivellClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NivellService#actualizaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	@Override
	public void actualizaNivell(Nivell nivell){
		dao.actualizaNivell(nivell);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NivellService#eliminaNivell(com.andujar.springmvc.domain.Nivell)
	 */
	@Override
	public void eliminaNivell(Nivell nivell){
		dao.eliminaNivell(nivell);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NivellService#obteNivell(long)
	 */
	@Override
	public Nivell obteNivell(long idNivell) {
		return dao.obteNivell(idNivell);
	}
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NivellService#obteLlistaNivell()
	 */
	@Override
	public List<Nivell> obteLlistaNivell(){
		
		return dao.obteLlistaNivells();
	}


	@Override
	public List<Nivell> obteLlistaNivellsPerAssignatura(long assignaturaId) {
		return dao.obteLlistaNivellsPerAssignatura(assignaturaId);
	}
	
	
	

}
