package com.andujar.springmvc.service;



import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.ActivitatAvaluadora;
import com.andujar.springmvc.domain.NotaDefinitivaActivitat;
import com.andujar.springmvc.domain.PeriodeAvaluacio;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class NotaDefinitivaActivitatServiceImpl implements NotaDefinitivaActivitatService  {
	
	NotaDefinitivaActivitat notaDefinitivaActivitatClass;

	@Autowired
	private NotaDefinitivaActivitatDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NotaDefinitivaActivitatService#guardaNotaDefinitivaActivitat(com.andujar.springmvc.domain.NotaDefinitivaActivitat)
	 */
	@Override
	public long guardaNotaDefinitivaActivitat(NotaDefinitivaActivitat notaDefinitivaActivitat){
		return dao.guardaNotaDefinitivaActivitat  (notaDefinitivaActivitat);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NotaDefinitivaActivitatService#guardaNotaDefinitivaActivitat(com.andujar.springmvc.domain.PeriodeAvaluacio, com.andujar.springmvc.domain.ActivitatAvaluadora, java.lang.Double, java.lang.Double)
	 */
	@Override
	public long guardaNotaDefinitivaActivitat (PeriodeAvaluacio periodeAvaluacio,
			ActivitatAvaluadora activitatAvaluadora, Double mitjana,
			Double notaReal){
		notaDefinitivaActivitatClass = new NotaDefinitivaActivitat (periodeAvaluacio,
				activitatAvaluadora,mitjana,notaReal);
		return dao.guardaNotaDefinitivaActivitat  (notaDefinitivaActivitatClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NotaDefinitivaActivitatService#actualizaNotaDefinitivaActivitat(com.andujar.springmvc.domain.NotaDefinitivaActivitat)
	 */
	@Override
	public void actualizaNotaDefinitivaActivitat(NotaDefinitivaActivitat notaDefinitivaActivitat){
		dao.actualizaNotaDefinitivaActivitat(notaDefinitivaActivitat);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NotaDefinitivaActivitatService#eliminaNotaDefinitivaActivitat(com.andujar.springmvc.domain.NotaDefinitivaActivitat)
	 */
	@Override
	public void eliminaNotaDefinitivaActivitat(NotaDefinitivaActivitat notaDefinitivaActivitat){
		dao.eliminaNotaDefinitivaActivitat(notaDefinitivaActivitat);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NotaDefinitivaActivitatService#obteNotaDefinitivaActivitat(long)
	 */
	@Override
	public NotaDefinitivaActivitat obteNotaDefinitivaActivitat(long idNotaDefinitivaActivitat) {
		return dao.obteNotaDefinitivaActivitat(idNotaDefinitivaActivitat);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.NotaDefinitivaActivitatService#obteLlistaNotaDefinitivaActivitat()
	 */
	@Override
	public List<NotaDefinitivaActivitat> obteLlistaNotaDefinitivaActivitat(){
		
		return dao.obteLlistaNotaDefinitivaActivitats();
	}
	
	

}
