package com.andujar.springmvc.service;




import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.AvaluacioAnyAcademic;
import com.andujar.springmvc.domain.Matricula;
import com.andujar.springmvc.domain.PeriodeAvaluacio;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class PeriodeAvaluacioServiceImpl implements PeriodeAvaluacioService  {
	
	PeriodeAvaluacio periodeAvaluacioClass;

	@Autowired
	private PeriodeAvaluacioDAO dao;
	
	@Autowired
	private MatriculaService matriculaService;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.PeriodeAvaluacioService#guardaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	@Override
	public long guardaPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio){
		return dao.guardaPeriodeAvaluacio  (periodeAvaluacio);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.PeriodeAvaluacioService#guardaPeriodeAvaluacio(com.andujar.springmvc.domain.Matricula, com.andujar.springmvc.domain.AvaluacioAnyAcademic)
	 */
	@Override
	public long guardaPeriodeAvaluacio(Matricula matricula,
			AvaluacioAnyAcademic avaluacioAnyAcademic){
		periodeAvaluacioClass = new PeriodeAvaluacio(matricula,
				avaluacioAnyAcademic);
		return dao.guardaPeriodeAvaluacio  (periodeAvaluacioClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.PeriodeAvaluacioService#actualizaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	@Override
	public void actualizaPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio){
		dao.actualizaPeriodeAvaluacio(periodeAvaluacio);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.PeriodeAvaluacioService#eliminaPeriodeAvaluacio(com.andujar.springmvc.domain.PeriodeAvaluacio)
	 */
	@Override
	public void eliminaPeriodeAvaluacio(PeriodeAvaluacio periodeAvaluacio){
		dao.eliminaPeriodeAvaluacio(periodeAvaluacio);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.PeriodeAvaluacioService#obtePeriodeAvaluacio(long)
	 */
	@Override
	public PeriodeAvaluacio obtePeriodeAvaluacio(long idPeriodeAvaluacio) {
		return dao.obtePeriodeAvaluacio(idPeriodeAvaluacio);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.PeriodeAvaluacioService#obteLlistaPeriodeAvaluacio()
	 */
	@Override
	public List<PeriodeAvaluacio> obteLlistaPeriodeAvaluacio(){
		
		return dao.obteLlistaPeriodeAvaluacios();
	}
	
	@Override
	public List<PeriodeAvaluacio> obteLlistaPeriodeAvaluacios(Long matriculaId, Long avaluacioAnyAcademic)
	{
		
		return dao.obteLlistaPeriodeAvaluacios(matriculaId, avaluacioAnyAcademic);
	}
	
	
	public PeriodeAvaluacio obtePeriodeAvaluacio(Long anyAcademicId, Long alumneId, Long nivellId, Long avaluacioAnyAcademic)
	{
		
		//--utilitza matriculaSercice per seleccionar matricula donada un any academic, alumne i nivell assignatura. Amb aquesta informacio pot cridar l'anterior mtode, que jo s que noms retornar un resultat
		System.out.println ("PeriodeAvaluacioService.obtePeriodeAvaluacio(Long anyAcademicId, Long alumneId, Long nivellId, Long avaluacioAnyAcademic) executant-se");
		return dao.obtePeriodeAvaluacio(matriculaService.obteMatricula(anyAcademicId, alumneId, nivellId), avaluacioAnyAcademic);	
	}
	
	
	

}

