package com.andujar.springmvc.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.AreaActivitat;
import com.andujar.springmvc.domain.PeriodeAvaluacio;
import com.andujar.springmvc.domain.QualificacioAreaActivitat;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class QualificacioAreaActivitatServiceImpl implements ActualitzaAreaQualificacioService, QualificacioAreaActivitatService {

	QualificacioAreaActivitat qualificacioAreaActivitatClass;

	@Autowired
	private QualificacioAreaActivitatDAO dao;

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActualitzaAreaQualificacioService#guardaQualificacioAreaActivitat(com.andujar.springmvc.domain.QualificacioAreaActivitat)
	 */
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaActivitatService#guardaQualificacioAreaActivitat(com.andujar.springmvc.domain.QualificacioAreaActivitat)
	 */
	
	@Override
	public long guardaQualificacioAreaActivitat(
			QualificacioAreaActivitat qualificacioAreaActivitat) {
		return dao.guardaQualificacioAreaActivitat(qualificacioAreaActivitat);
	}

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActualitzaAreaQualificacioService#guardaQualificacioAreaActivitat(com.andujar.springmvc.domain.AreaActivitat, com.andujar.springmvc.domain.PeriodeAvaluacio, java.lang.Double, java.lang.Double)
	 */
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaActivitatService#guardaQualificacioAreaActivitat(com.andujar.springmvc.domain.AreaActivitat, com.andujar.springmvc.domain.PeriodeAvaluacio, java.lang.Double, java.lang.Double)
	 */
	
	@Override
	public long guardaQualificacioAreaActivitat(AreaActivitat areaActivitat,
			PeriodeAvaluacio periodeAvaluacio, Double nota,
			Double percentatgeReal) {
		qualificacioAreaActivitatClass = new QualificacioAreaActivitat(
				areaActivitat, periodeAvaluacio, nota, percentatgeReal);
		return dao
				.guardaQualificacioAreaActivitat(qualificacioAreaActivitatClass);
	}

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActualitzaAreaQualificacioService#actualizaQualificacioAreaActivitat(com.andujar.springmvc.domain.QualificacioAreaActivitat)
	 */
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaActivitatService#actualizaQualificacioAreaActivitat(com.andujar.springmvc.domain.QualificacioAreaActivitat)
	 */
	
	@Override
	public void actualizaQualificacioAreaActivitat(
			QualificacioAreaActivitat qualificacioAreaActivitat) {
		dao.actualizaQualificacioAreaActivitat(qualificacioAreaActivitat);
	}

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActualitzaAreaQualificacioService#eliminaQualificacioAreaActivitat(com.andujar.springmvc.domain.QualificacioAreaActivitat)
	 */
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaActivitatService#eliminaQualificacioAreaActivitat(com.andujar.springmvc.domain.QualificacioAreaActivitat)
	 */

	@Override
	public void eliminaQualificacioAreaActivitat(
			QualificacioAreaActivitat qualificacioAreaActivitat) {
		dao.eliminaQualificacioAreaActivitat(qualificacioAreaActivitat);
	}

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActualitzaAreaQualificacioService#obteQualificacioAreaActivitat(long)
	 */
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaActivitatService#obteQualificacioAreaActivitat(long)
	 */

	@Override
	public QualificacioAreaActivitat obteQualificacioAreaActivitat(
			long idQualificacioAreaActivitat) {
		return dao.obteQualificacioAreaActivitat(idQualificacioAreaActivitat);
	}

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.ActualitzaAreaQualificacioService#obteLlistaQualificacioAreaActivitat()
	 */
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaActivitatService#obteLlistaQualificacioAreaActivitat()
	 */

	@Override
	public List<QualificacioAreaActivitat> obteLlistaQualificacioAreaActivitat() {

		return dao.obteLlistaQualificacioAreaActivitats();
	}

}
