package com.andujar.springmvc.service;




import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.AreaAssignatura;
import com.andujar.springmvc.domain.PeriodeAvaluacio;
import com.andujar.springmvc.domain.QualificacioArea;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class QualificacioAreaServiceImpl implements QualificacioAreaService  {
	
	QualificacioArea qualificacioAreaClass;

	@Autowired
	private QualificacioAreaDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaService#guardaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	@Override
	public long guardaQualificacioArea(QualificacioArea qualificacioArea){
		return dao.guardaQualificacioArea  (qualificacioArea);
	}


	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaService#guardaQualificacioArea(com.andujar.springmvc.domain.AreaAssignatura, com.andujar.springmvc.domain.PeriodeAvaluacio, java.lang.Double, java.util.Date)
	 */
	@Override
	public long guardaQualificacioArea(AreaAssignatura areaAssignatura,
			PeriodeAvaluacio periodeAvaluacio, Double nota, Date dataAlta) {
		qualificacioAreaClass = new QualificacioArea(areaAssignatura,
				periodeAvaluacio, nota, dataAlta) ;
		return dao.guardaQualificacioArea  (qualificacioAreaClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaService#actualizaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	@Override
	public void actualizaQualificacioArea(QualificacioArea qualificacioArea){
		dao.actualizaQualificacioArea(qualificacioArea);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaService#eliminaQualificacioArea(com.andujar.springmvc.domain.QualificacioArea)
	 */
	@Override
	public void eliminaQualificacioArea(QualificacioArea qualificacioArea){
		dao.eliminaQualificacioArea(qualificacioArea);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaService#obteQualificacioArea(long)
	 */
	@Override
	public QualificacioArea obteQualificacioArea(long idQualificacioArea) {
		return dao.obteQualificacioArea(idQualificacioArea);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.QualificacioAreaService#obteLlistaQualificacioArea()
	 */
	@Override
	public List<QualificacioArea> obteLlistaQualificacioArea(){
		
		return dao.obteLlistaQualificacioAreas();
	}
	
	
	@Override
	public List<QualificacioArea> obteLlistaQualificacioAreasPeriode(Long periodeAvaluacioId){
		
		return dao.obteLlistaQualificacioAreasPeriode(periodeAvaluacioId);
	}

}

