package com.andujar.springmvc.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.andujar.springmvc.domain.PerfilUsuari;
import com.andujar.springmvc.domain.Usuari;
import com.andujar.springmvc.exception.Excepcio;
import com.andujar.springmvc.repository.*;

@Component
@Transactional
public class UsuariServiceImpl implements UsuariService  {
	
	Usuari usuariClass;

	@Autowired
	private UsuariDAO dao;
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.UsuariService#guardaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	@Override
	public long guardaUsuari(Usuari usuari){
		return dao.guardaUsuari  (usuari);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.UsuariService#guardaUsuari(java.lang.String, java.lang.String, int, java.lang.String, java.lang.String, java.lang.String, java.util.Date)
	 */
	@Override
	public long guardaUsuari(String usuari, String contrassenya, PerfilUsuari perfil, String nom,
			String cognom1, String cognom2)throws Excepcio {
		usuariClass = new Usuari(usuari, contrassenya, perfil, nom,
				cognom1,  cognom2); 
		return dao.guardaUsuari  (usuariClass);
	}

	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.UsuariService#actualizaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	@Override
	public void actualizaUsuari(Usuari usuari){
		dao.actualizaUsuari(usuari);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.UsuariService#eliminaUsuari(com.andujar.springmvc.domain.Usuari)
	 */
	@Override
	public void eliminaUsuari(Usuari usuari){
		dao.eliminaUsuari(usuari);
	}
	
	
	
	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.UsuariService#obteUsuari(long)
	 */
	@Override
	public Usuari obteUsuari(long idUsuari) {
		return dao.obteUsuari(idUsuari);
	}
	

	/* (non-Javadoc)
	 * @see com.andujar.springmvc.service.UsuariService#obteLlistaUsuari()
	 */
	@Override
	public List<Usuari> obteLlistaUsuari(){
		
		return dao.obteLlistaUsuaris();
	}
	
	@Override
	public List<Usuari> obteLlistaAlumnes() {
		return dao.obteLlistaAlumnes();
	}
	
	//
	@Override
	public List<Usuari> obteLlistaProfessors(){
		return dao.obteLlistaProfessors();
	}
	
	@Override
	public List<Usuari> obteLlistaAdministradors(){
		return dao.obteLlistaAdministradors();
	}
	
	@Override
	public List<Usuari> obteLlistaPares(){
		return dao.obteLlistaPares();
	}
	
	
	//
	
	@Override
	public List<Usuari> obteLlistaAlumnesMatriculats(Long anyAcademicId, Long nivellId){
		System.out.println("UsuariService.obteLlistaAlumnesMatriculats executant-se");
		return dao.obteLlistaAlumnesMatriculats(anyAcademicId, nivellId);
	}
	
	

}
