package com.andujar.springmvc.web;



import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import com.andujar.springmvc.domain.PerfilUsuari;
import com.andujar.springmvc.domain.Usuari;
import com.andujar.springmvc.service.UsuariService;
import com.andujar.springmvc.exception.Excepcio;


@Controller
public class AdministradorController {
	
	@Autowired
	private UsuariService usuariService;
	
	
	
	@RequestMapping(value = "/usuaris", method = RequestMethod.GET)
	public String inserirNotesActivitats(Model model,
			@RequestParam (required = false) String perfil_selected,
			@RequestParam (required = false) Long crear_usuari,
			
			@RequestParam (required = false) Long usuari_modificat,
			@RequestParam (required = false) String usuari_perfil_modificar,
			@RequestParam (required = false) String usuari_nom_modificar,
			@RequestParam (required = false) String usuari_cognom1_modificar,
			@RequestParam (required = false) String usuari_cognom2_modificar,
			@RequestParam (required = false) String usuari_usuari_modificar,
			@RequestParam (required = false) String usuari_contrasenya_modificar,
			
			@RequestParam (required = false) String usuari_perfil_inserir,
			@RequestParam (required = false) String usuari_nom_inserir,
			@RequestParam (required = false) String usuari_cognom1_inserir,
			@RequestParam (required = false) String usuari_cognom2_inserir,
			@RequestParam (required = false) String usuari_usuari_inserir,
			@RequestParam (required = false) String usuari_contrasenya_inserir){
	
		  model.addAttribute("perfils", PerfilUsuari.values());
		 
			
			
			//Insereix usuari
			if (crear_usuari != null){
				try{
					
					usuariService.guardaUsuari(usuari_usuari_inserir, usuari_contrasenya_inserir, 
							PerfilUsuari.valueOf(usuari_perfil_inserir), usuari_nom_inserir, usuari_cognom1_inserir, 
							usuari_cognom2_inserir );
					
				}catch (Excepcio e){
					model.addAttribute("adviceMessage", "No s'ha pogut desar l'usuari. <br>"+e.getMessage());
					e.printStackTrace();
					return "adm_ususaris";
				}
			}
			
		
			//Modifica usuari
			if (usuari_modificat != null){
				if (
						usuari_nom_modificar == "" ||
						usuari_cognom1_modificar == "" ||
						usuari_cognom2_modificar == "" ||
						usuari_usuari_modificar == "" ||
						usuari_contrasenya_modificar == ""){
					
					model.addAttribute("adviceMessage", "No s'ha pogut modificar l'usuari. <br>"
 							+"No es pot deixar cap camp en blanc.");
					
					
					
				}else{
					
					Usuari usuari = usuariService.obteUsuari(usuari_modificat);
					
					
					usuari.setNom(usuari_nom_modificar);
					usuari.setCognom1(usuari_cognom1_modificar);
					usuari.setCognom2(usuari_cognom2_modificar);
					usuari.setUsuari(usuari_usuari_modificar);
					usuari.setContrassenya(usuari_contrasenya_modificar);
					
					usuariService.actualizaUsuari(usuari);	
				}
			}
			
				
				//Inserim al model el llistat d'usuaris segons filtre ADMINISTRADOR, PROFESSOR, ALUMNE, PARE, TOTS
				PerfilUsuari perfil = null;
				if (perfil_selected !=null && !perfil_selected.equals("") ) {
					perfil = PerfilUsuari.valueOf(perfil_selected);
					switch (perfil){
					
					case ADMINISTRADOR:
						System.out.println("Numeros switch 0");
						model.addAttribute("usuaris", usuariService.obteLlistaAdministradors());
					
						break;
						
					case PROFESSOR:
						System.out.println("Numeros switch 1");
						model.addAttribute("usuaris", usuariService.obteLlistaProfessors());
						break;	
						
					case ALUMNE:
						System.out.println("Numeros switch 2");
						model.addAttribute("usuaris", usuariService.obteLlistaAlumnes());
						break;	
						
					case PARE:
						System.out.println("Numeros switch 3");
						model.addAttribute("usuaris", usuariService.obteLlistaPares());
						break;
					}	
				} else {
					model.addAttribute("usuaris", usuariService.obteLlistaUsuari());

				}

		return "adm_ususaris";
	}

}
