package com.andujar.springmvc.web;

import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import com.andujar.springmvc.domain.AvaluacioAnyAcademic;
import com.andujar.springmvc.domain.PeriodeAvaluacio;
import com.andujar.springmvc.service.ActivitatAvaluadoraService;
import com.andujar.springmvc.service.AnyAcademicService;
import com.andujar.springmvc.service.AreaActivitatService;
import com.andujar.springmvc.service.AreaAssignaturaService;
import com.andujar.springmvc.service.AssignaturaService;
import com.andujar.springmvc.service.AvaluacioAnyAcademicService;
import com.andujar.springmvc.service.NivellService;
import com.andujar.springmvc.service.PeriodeAvaluacioService;
import com.andujar.springmvc.service.QualificacioAreaActivitatService;
import com.andujar.springmvc.service.QualificacioAreaService;
import com.andujar.springmvc.service.UnitatDidacticaService;
import com.andujar.springmvc.service.UsuariService;


@Controller
public class NotesController {
	
	@Autowired
	private AnyAcademicService anyAcademicService;
	
	@Autowired
	private AvaluacioAnyAcademicService avaluacioAnyAcademicService;
	
	@Autowired
	private AssignaturaService assignaturaService;
	
	@Autowired
	private NivellService nivellService;
	
	@Autowired
	private UnitatDidacticaService unitatDidacticaService;
	
	@Autowired
	private ActivitatAvaluadoraService activitatAvaluadoraService;
	
	@Autowired
	private AreaAssignaturaService areaAssignaturaService;
	
	@Autowired
	private UsuariService usuariService ;
	
	@Autowired
	private AreaActivitatService areaActivitatService;
	
	@Autowired
	private PeriodeAvaluacioService periodeAvaluacioService;
	
	@Autowired
	private QualificacioAreaService qualificacioAreaService;
	
	@Autowired
	private QualificacioAreaActivitatService qualificacioAreaActivitatService;
	
	
	
	@RequestMapping(value = "/consultarPerArees", method = RequestMethod.GET)
	public String consultaNotesArees(Model model,
			@RequestParam (required = false) Long any_selected,
			@RequestParam (required = false) Long avaluacio_selected,
			@RequestParam (required = false) Long assignatura_selected, 
			@RequestParam (required = false) Long nivell_selected,
			@RequestParam (required = false) Long alumne_selected){
		
		PeriodeAvaluacio periodeAvaluacio;
		
		if (any_selected != null){
			model.addAttribute("avaluacions", avaluacioAnyAcademicService.obteLlistaAvaluacioAnyAcademic(any_selected));
		}
		
		if (avaluacio_selected != null){
			
			if (assignatura_selected != null){
				
				model.addAttribute("nivells", nivellService.obteLlistaNivellsPerAssignatura(assignatura_selected));
					
					
				if (nivell_selected != null){
					
					model.addAttribute("alumnes",usuariService.obteLlistaAlumnesMatriculats(any_selected, nivell_selected) );
					//Inserim AreesAssignatura del nivell seleccionat
					model.addAttribute("arees", areaAssignaturaService.obteLlistaAreaAssignaturasAltaNivell(nivell_selected));
					
					if (alumne_selected != null){
						
						
						System.out.println("NotesController crida a periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected);");
						periodeAvaluacio = periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected);
						
						System.out.println("NotesController ha retornat de periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected);");
						//Inserim al model les qualificacions d'rea
						model.addAttribute("quallificacions", qualificacioAreaService.obteLlistaQualificacioAreasPeriode(periodeAvaluacio.getId()));
						
					}	
				}
			}
		}
		
		model.addAttribute("anys", anyAcademicService.obteLlistaAnyAcademic() );
		model.addAttribute("assignatures", assignaturaService.obteLlistaAssignatura() );
		
		
		return "P_consultar_notes_per_arees";
	}

	@RequestMapping(value = "/consultarPerUnitats", method = RequestMethod.GET)
	public String consultaNotesUnitats(Model model,
			@RequestParam (required = false) Long any_selected,
			@RequestParam (required = false) Long avaluacio_selected,
			@RequestParam (required = false) Long assignatura_selected, 
			@RequestParam (required = false) Long nivell_selected,
			@RequestParam (required = false) Long unitat_selected,
			@RequestParam (required = false) Long alumne_selected){
		
		if (any_selected != null){
			model.addAttribute("avaluacions", avaluacioAnyAcademicService.obteLlistaAvaluacioAnyAcademic(any_selected));
		}
		
		if (avaluacio_selected != null){
			
			if (assignatura_selected != null){
				
				model.addAttribute("nivells", nivellService.obteLlistaNivellsPerAssignatura(assignatura_selected));
					
					
				if (nivell_selected != null){
					//Inserim al model totes les unitats didctiques que hagin estat d'alta dintre del perde de l'avaluaci d'any acadmic seleccionat	
					model.addAttribute("unitats", unitatDidacticaService.obteLlistaUnitatDidacticasAltaAvaluacio(nivell_selected, avaluacioAnyAcademicService.obteAvaluacioAnyAcademic(avaluacio_selected).getDatFi()));
					
					model.addAttribute("alumnes",usuariService.obteLlistaAlumnesMatriculats(any_selected, nivell_selected) );
					
					if (unitat_selected != null){
						// Inserim al model totes les acativitats avaluables que hagin estat d'alta dintre del perde de l'avaluaci d'any acadmic seleccionat	
						model.addAttribute("activitats", activitatAvaluadoraService.obteLlistaActivitatAvaluadoresPeriodeAvaluacio(unitat_selected, periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected).getId()));
						//Inserim AreesAssignatura del nivell seleccionat
						model.addAttribute("arees", areaAssignaturaService.obteLlistaAreaAssignaturasAltaNivell(nivell_selected));
						
						//Inserim PeriodeAvaluacio 
						model.addAttribute("periodeAvaluacio", periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected));
						
					}
				}
			}
		}
		
		model.addAttribute("anys", anyAcademicService.obteLlistaAnyAcademic() );
		model.addAttribute("assignatures", assignaturaService.obteLlistaAssignatura() );
		
		return "P_consultar_notes_unitats";
	}
	
	
	 @RequestMapping(value = "/inserirNotesArees", method = RequestMethod.GET)
	public String inserirNotesArees(Model model,
			@RequestParam (required = false) Long assignatura_selected, 
			@RequestParam (required = false) Long nivell_selected,
			@RequestParam (required = false) Long alumne_selected,
			
			@RequestParam (required = false) Long inserir,
			@RequestParam (required = false) List <String> notes_inserir,
			@RequestParam (required = false) List <String> area_inserir_id){
		
		 
		
		 
		PeriodeAvaluacio periodeAvaluacio;
		
		AvaluacioAnyAcademic avaluacioEnCurs = avaluacioAnyAcademicService.obteCurrentAvaluacioAnyAcademics(new Date());
		model.addAttribute("avaluacio_selected", avaluacioEnCurs.getId());
			
			if (assignatura_selected != null){
				
				model.addAttribute("nivells", nivellService.obteLlistaNivellsPerAssignatura(assignatura_selected));
					
					
				if (nivell_selected != null){
					model.addAttribute("alumnes",usuariService.obteLlistaAlumnesMatriculats(avaluacioEnCurs.getAnyAcademic().getId(), nivell_selected) );
					//Inserim AreesAssignatura del nivell seleccionat
					model.addAttribute("arees", areaAssignaturaService.obteLlistaAreaAssignaturasAltaNivell(nivell_selected));
					
					if (alumne_selected != null){
						
						System.out.println("NotesController crida a periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected);");
						periodeAvaluacio = periodeAvaluacioService.obtePeriodeAvaluacio(avaluacioEnCurs.getAnyAcademic().getId(), alumne_selected, nivell_selected, avaluacioEnCurs.getId());
						
						System.out.println("NotesController ha retornat de periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected);");
						//System.out.println("NotesController periodeAvaluacio "+periodeAvaluacio);
						
						
						System.out.println("NotesControllerArea valor inserir = "+inserir);
						if (inserir != null){
							
							System.out.println("NotesControllerArea comena a inserir");
							
							Iterator <String> arees = area_inserir_id.iterator();
							Iterator <String> notes = notes_inserir.iterator();
							
							Long areaId;
							String notaStr;
							Double nota;
							String adviceMessage = "";
							
							while (arees.hasNext()){
								areaId = Long.parseLong(arees.next());
								System.out.println("NotesController areaId a inserir = "+areaId);
								notaStr = notes.next();
								System.out.println("NotesController nota a inserir = "+notaStr);
								if (notaStr != ""){
									try{
										nota = Double.parseDouble(notaStr);
										if (nota >= 0 && nota<=10){
											qualificacioAreaService.guardaQualificacioArea(areaAssignaturaService.obteAreaAssignatura(areaId), periodeAvaluacio, nota, new Date());
										}else{
											adviceMessage = adviceMessage+ "Les notes a inserir han de ser un nmero entre 0 i 10. <br>"
													+ "No s correcte el valor '"+notaStr+"' per l'rea "+areaAssignaturaService.obteAreaAssignatura(areaId).getNom()+".<br>";
										}
									}catch (Exception e){
										 adviceMessage = adviceMessage+ "Les notes a inserir han de ser un nmero. <br>"
												+  "No s correcte el valor '"+notaStr+"' per l'rea "
												 +areaAssignaturaService.obteAreaAssignatura(areaId).getNom()+ ".  <br>"+e.getMessage()+".<br>";
									}
								}
								
							}
							model.addAttribute("adviceMessage", adviceMessage);
						}
					}	
				}
			}
		
		model.addAttribute("assignatures", assignaturaService.obteLlistaAssignatura() );
		
		
		return "P_inserir_notes_arees";
	}
	
	
	
	@RequestMapping(value = "/inserirPerUnitats", method = RequestMethod.GET)
	public String insereixNotesUnitats(Model model,
			
			@RequestParam (required = false) Long assignatura_selected, 
			@RequestParam (required = false) Long nivell_selected,
			@RequestParam (required = false) Long unitat_selected,
			@RequestParam (required = false) Long alumne_selected,
			
			@RequestParam (required = false) Long activitat_inserir,
			@RequestParam (required = false) List <String> notes_inserir,
			@RequestParam (required = false) List <String> area_inserir_id){
		
		System.out.println("NotesControllerArea valor inserir = "+activitat_inserir);
		PeriodeAvaluacio periodeAvaluacio;
		
		AvaluacioAnyAcademic avaluacioEnCurs = avaluacioAnyAcademicService.obteCurrentAvaluacioAnyAcademics(new Date());
		model.addAttribute("avaluacio_selected", avaluacioEnCurs.getId());
		
			if (assignatura_selected != null){
				
				model.addAttribute("nivells", nivellService.obteLlistaNivellsPerAssignatura(assignatura_selected));
					
					
				if (nivell_selected != null){
					//Inserim al model totes les unitats didctiques que hagin estat d'alta dintre del perde de l'avaluaci d'any acadmic seleccionat	
					model.addAttribute("unitats", unitatDidacticaService.obteLlistaUnitatDidacticasAltaAvaluacio(nivell_selected, avaluacioEnCurs.getDatFi()));
					
					model.addAttribute("alumnes",usuariService.obteLlistaAlumnesMatriculats(avaluacioEnCurs.getAnyAcademic().getId(), nivell_selected) );
					
					if (unitat_selected != null){
						// Inserim al model totes les acativitats avaluables que hagin estat d'alta dintre del perde de l'avaluaci d'any acadmic seleccionat	
						model.addAttribute("activitats", activitatAvaluadoraService.obteLlistaActivitatAvaluadoresAvaluacioAnyAcademic(unitat_selected, avaluacioEnCurs.getDatFi()));
						//Inserim AreesAssignatura del nivell seleccionat
						model.addAttribute("arees", areaAssignaturaService.obteLlistaAreaAssignaturasAltaNivell(nivell_selected));
						
						//Inserim PeriodeAvaluacio 
						System.out.println("NotesController crida a periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected);");
						periodeAvaluacio = periodeAvaluacioService.obtePeriodeAvaluacio(avaluacioEnCurs.getAnyAcademic().getId(), alumne_selected, nivell_selected, avaluacioEnCurs.getId());
						
						System.out.println("NotesController ha retornat de periodeAvaluacioService.obtePeriodeAvaluacio(any_selected, alumne_selected, nivell_selected, avaluacio_selected);");
						System.out.println("NotesController periodeAvaluacio "+periodeAvaluacio.getId());
						
						
						if (activitat_inserir != null){
							
							System.out.println("NotesControllerArea comena a inserir");
							
							Iterator <String> arees = area_inserir_id.iterator();
							Iterator <String> notes = notes_inserir.iterator();
							
							Long areaId;
							String notaStr;
							Double nota;
							String adviceMessage = "";
							
							while (arees.hasNext()){
								areaId = Long.parseLong(arees.next());
								System.out.println("NotesController areaId a inserir = "+areaId);
								notaStr = notes.next();
								System.out.println("NotesController nota a inserir = "+notaStr);
								if (notaStr != ""){
									try{
										nota = Double.parseDouble(notaStr);
										if (nota >= 0 && nota<=10){
											qualificacioAreaActivitatService.guardaQualificacioAreaActivitat(areaActivitatService.obteAreaActivitat(areaId), periodeAvaluacio, nota, null);
										}else{
											adviceMessage = adviceMessage+ "Les notes a inserir han de ser un nmero entre 0 i 10. <br>"
													+ "No s correcte el valor '"+notaStr+"' per l'rea "+areaAssignaturaService.obteAreaAssignatura(areaId).getNom()+".<br>";
										}
									}catch (Exception e){
										 adviceMessage = adviceMessage+ "Les notes a inserir han de ser un nmero. <br>"
												+  "No s correcte el valor '"+notaStr+"' per l'rea "
												 +areaAssignaturaService.obteAreaAssignatura(areaId).getNom()+ ".  <br>"+e.getMessage()+".<br>";
									}
								}
								
							}
							model.addAttribute("adviceMessage", adviceMessage);
							//Refrescam les dades per a mostrar les noves dades inserides
							periodeAvaluacio = periodeAvaluacioService.obtePeriodeAvaluacio(avaluacioEnCurs.getAnyAcademic().getId(), alumne_selected, nivell_selected, avaluacioEnCurs.getId());
						}
						
						model.addAttribute("periodeAvaluacio", periodeAvaluacio);
					}
				}
			}
		
		
		model.addAttribute("anys", anyAcademicService.obteLlistaAnyAcademic() );
		model.addAttribute("assignatures", assignaturaService.obteLlistaAssignatura() );
		
		return "P_inserir_notes_unitats";
	}

}
