package com.andujar.springmvc.web;


import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import com.andujar.springmvc.domain.ActivitatAvaluadora;
import com.andujar.springmvc.domain.AreaActivitat;
import com.andujar.springmvc.domain.AreaAssignatura;
import com.andujar.springmvc.domain.UnitatDidactica;
import com.andujar.springmvc.exception.Excepcio;
import com.andujar.springmvc.service.ActivitatAvaluadoraService;
import com.andujar.springmvc.service.AreaActivitatService;
import com.andujar.springmvc.service.AreaAssignaturaService;
import com.andujar.springmvc.service.AssignaturaService;
import com.andujar.springmvc.service.NivellService;
import com.andujar.springmvc.service.UnitatDidacticaService;

@Controller
public class ProgramacioController {

	

	
	@Autowired
	private AssignaturaService assignaturaService;
	
	@Autowired
	private NivellService nivellService;
	
	@Autowired
	private UnitatDidacticaService unitatDidacticaService;
	
	@Autowired
	private ActivitatAvaluadoraService activitatAvaluadoraService;
	
	@Autowired
	private AreaAssignaturaService areaAssignaturaService;
	
	@Autowired
	private AreaActivitatService areaActivitatService;
	
	
	 @RequestMapping(value = "/programacio", method = RequestMethod.GET)
		public String programacio(Model model, 
				@RequestParam (required = false) Long assignatura_selected,  
				@RequestParam (required = false) Long nivell_selected, 
				
				@RequestParam (required = false) Long area_esborrar,
				@RequestParam (required = false) Long area_modificada,
				@RequestParam (required = false) String area_nom_modificar,
				@RequestParam (required = false) String area_descripcio_modificar,
				@RequestParam (required = false) Long crear_area,
				@RequestParam (required = false) String area_nom_inserir,
				@RequestParam (required = false) String area_descripcio_inserir,
				
				@RequestParam (required = false) Long unitat_esborrar,
				@RequestParam (required = false) Long unitat_modificada,
				@RequestParam (required = false) Long unitat_numero_modificar,
				@RequestParam (required = false) String unitat_titol_modificar,
				@RequestParam (required = false) Long crear_unitat,
				@RequestParam (required = false) Long unitat_numero_inserir,
				@RequestParam (required = false) String unitat_titol_inserir){
			
		 
		
		 
		 

			
			if (area_esborrar != null){
				 System.out.println("S'ha premut bot esborrar rea. Area a esborrar: "+area_esborrar);
				 AreaAssignatura area = areaAssignaturaService.obteAreaAssignatura(area_esborrar);
				 System.out.println("Area a esborrar: "+area);
				 areaAssignaturaService.donaBaixaAreaAssignatura(area_esborrar);
			 }
			 
			 
			 if (area_modificada !=null){
				 if (area_nom_modificar != ""){
					 AreaAssignatura area = areaAssignaturaService.obteAreaAssignatura(area_modificada);
					 area.setNom(area_nom_modificar);
					 area.setDescripcio(area_descripcio_modificar);
					 areaAssignaturaService.actualizaAreaAssignatura(area);
				 }else{
					 model.addAttribute("adviceMessage", "No s'ha pogut modificar l'rea. <br>"
							 							+"El nom de l'rea no pot estar buit.");
				 }
			 }
			 
			 if (crear_area !=null){
				 
				 try {
					areaAssignaturaService.guardaAreaAssignatura(nivellService.obteNivell(nivell_selected), area_nom_inserir, area_descripcio_inserir, new Date(), null);
				} catch (Excepcio e) {
					
					model.addAttribute("adviceMessage", "No s'ha pogut desar l'rea. <br>"+e.getMessage());
					e.printStackTrace();
				}
			 }
			
			 if (unitat_esborrar !=null){
				 System.out.println("S'ha premut bot esborrar unitat. Unitat a esborrar: "+unitat_esborrar);
				 UnitatDidactica unitat = unitatDidacticaService.obteUnitatDidactica(unitat_esborrar);
				 System.out.println("Unitat a esborrar: "+ unitat.toString());
				 unitatDidacticaService.donaBaixaUnitatDidactica(unitat_esborrar);
			 }
			 
			 if (unitat_modificada != null){
				 if (unitat_numero_modificar!=null){
					 UnitatDidactica unitat = unitatDidacticaService.obteUnitatDidactica(unitat_modificada);
					 unitat.setNumero(unitat_numero_modificar);
					 unitat.setTitol(unitat_titol_modificar);
					 unitatDidacticaService.actualizaUnitatDidactica(unitat);
				 }else{
					 model.addAttribute("adviceMessage", "No s'ha pogut modificar la unitat didctica. <br>"
							 								+"El nmero de la unitat no pot estar buit");
				 }
			 }
			 
			 if (crear_unitat !=null){
				 try {
					unitatDidacticaService.guardaUnitatDidactica(nivellService.obteNivell(nivell_selected), unitat_numero_inserir, unitat_titol_inserir, new Date(), null);
				} catch (Excepcio e) {
					model.addAttribute("adviceMessage", "No s'ha pogut desar la unitat didctica. <br>"+e.getMessage());
					e.printStackTrace();
				}
			 }
			 
			if (assignatura_selected != null){
				
				model.addAttribute("nivells", nivellService.obteLlistaNivellsPerAssignatura(assignatura_selected));
				
				if (nivell_selected != null){
					
					model.addAttribute("arees",areaAssignaturaService.obteLlistaAreaAssignaturasAltaNivell(nivell_selected));
					model.addAttribute("unitats", unitatDidacticaService.obteLlistaUnitatDidacticaAlta(nivell_selected));
					
					
				}
				
			}
			model.addAttribute("assignatures", assignaturaService.obteLlistaAssignatura() );
			
			
			
			return "P4_programacio_arees_assignatures_unitats_didactiques";
		}
	
	

	
	 @RequestMapping(value = "/activitats", method = RequestMethod.GET)
		public String activitats(
				Model model, 
				@RequestParam (required = false) Long assignatura_selected, 
				@RequestParam (required = false) Long nivell_selected,
				@RequestParam (required = false) Long unitat_selected,
				
				@RequestParam (required = false) Long activitat_esborrar,
				
				//@RequestParam (required = false) Long activitat_modificar,
				@RequestParam (required = false) String activitat_modificar_nom,
				@RequestParam (required = false) Long  activitat_modificar_id,
				@RequestParam (required = false) Long activitat_modificada,
				@RequestParam (required = false) List <String> percentatges_modificar_value,
				@RequestParam (required = false) List <String> percentatges_midificar_id,
				@RequestParam (required = false) List <String> areesAssinatura_modificar_id,
				
				@RequestParam (required = false) Long crear_activitat,
				@RequestParam (required = false) String activitat_nom_inserir,
				@RequestParam (required = false) List <String> area_percentatges_inserir,
				@RequestParam (required = false) List <String> area_percentatges_inserir_id
				) {
			

			
		if (assignatura_selected != null){
				
			model.addAttribute("nivells", nivellService.obteLlistaNivellsPerAssignatura(assignatura_selected));
				
			if (nivell_selected != null){
					
				model.addAttribute("unitats", unitatDidacticaService.obteLlistaUnitatDidacticaAlta(nivell_selected));
					
				if (unitat_selected != null){
						
					model.addAttribute("activitats", activitatAvaluadoraService.obteLlistaActivitatAvaluadoraAlta(unitat_selected));
						
					model.addAttribute("arees", areaAssignaturaService.obteLlistaAreaAssignaturasAltaNivell(nivell_selected));
						
				}
			}
		}
		
		model.addAttribute("assignatures", assignaturaService.obteLlistaAssignatura() );
		
		
	//Esborrar activitat	
	if (activitat_esborrar != null){
		activitatAvaluadoraService.donaBaixaActivitatAvaluadora(activitat_esborrar);
	}
	
	//Inserir nova activitat
	if (crear_activitat != null){
		
			//Comprova que tots els % sumen un total de 100%
			if(! activitatAvaluadoraService.percentatgesComplet(area_percentatges_inserir)){
				model.addAttribute("adviceMessage", "Els percentatges de les diferents rees han de sumar un total de 100% <br>"
						+ "Comproveu la darrera activitat que acabeu de crear.");
			}
			
			Iterator <String> value = area_percentatges_inserir.iterator();
			Iterator <String> index = area_percentatges_inserir_id.iterator();
			String percentatgeStr;
			//Desem la nova activitat avaluadora
			ActivitatAvaluadora activitatAvaluadoraInserir;
			try {
				activitatAvaluadoraInserir = new ActivitatAvaluadora (unitatDidacticaService.obteUnitatDidactica(unitat_selected), activitat_nom_inserir, new Date(), null);
			} catch (Excepcio e1) {
				model.addAttribute("adviceMessage", "No s'ha pogut desar l'activitat avaluadora. <br>"
						+ e1.getMessage());
				e1.printStackTrace();
				return "P5_programacio_activitats_avaluables";
			}
			activitatAvaluadoraService.guardaActivitatAvaluadora(activitatAvaluadoraInserir);
			
			//Desem els corresponents percentatges de cadascuna de les arees que conformen aquesta activitat avaluadora
			while (index.hasNext()){
				
				try{
					percentatgeStr = value.next();
					
					if(percentatgeStr !=""){
						areaActivitatService.guardaAreaActivitat(areaAssignaturaService.obteAreaAssignatura(Long.parseLong(index.next().toString())), 
								activitatAvaluadoraInserir, Double.parseDouble(percentatgeStr) );
					}else{
						index.next();
					}
				}
				catch (Exception e){
					
					model.addAttribute("adviceMessage", "Als percentatges noms es poden introduir nombres. <br>"
								+ "Comproveu la darrera activitat que acabeu de crear.");
					System.out.println("Entra al cath");
					model.addAttribute("activitats", activitatAvaluadoraService.obteLlistaActivitatAvaluadoraAlta(unitat_selected));
					return "P5_programacio_activitats_avaluables";
					
				}			
			}
			model.addAttribute("activitats", activitatAvaluadoraService.obteLlistaActivitatAvaluadoraAlta(unitat_selected));
			
			
	}
	
	
	
	//Modificar activitat
		if (activitat_modificada != null){
				
				//Comprova que tots els % sumen un total de 100%
				if(! activitatAvaluadoraService.percentatgesComplet(percentatges_modificar_value)){
					model.addAttribute("adviceMessage", "Els percentatges de les diferents rees han de sumar un total de 100%"
							+ "Comproveu la darrera activitat que acabeu de modificar.");
				}
				
				Iterator <String> value = percentatges_modificar_value.iterator();
				Iterator <String> index = percentatges_midificar_id.iterator();
				Iterator <String> arees = areesAssinatura_modificar_id.iterator();
				String percentatgeStr;
				String indexString;
				Long areaActivitatId;
				String areaAssignaturaIdStr;
				//Modifiquem la nova activitat avaluadora
				if (activitat_modificar_nom ==""){
					model.addAttribute("adviceMessage", "No s'ha pogut modificar l'activitat avaluadora. <br>"
							+ "El nom de l'activitat no pot estar buit.");
					return "P5_programacio_activitats_avaluables";
				}
				ActivitatAvaluadora activitatAvaluadoraModificar = activitatAvaluadoraService.obteActivitatAvaluadora(activitat_modificar_id);
				System.out.println("activitatAvaluadoraModificar abans "+activitatAvaluadoraModificar.toString());
				activitatAvaluadoraModificar.setNom(activitat_modificar_nom);
				System.out.println("activitatAvaluadoraModificar desprs "+activitatAvaluadoraModificar.toString());
				activitatAvaluadoraService.actualizaActivitatAvaluadora(activitatAvaluadoraModificar);
				System.out.println("activitatAvaluadoraModificar inseri t"+ activitatAvaluadoraService.obteActivitatAvaluadora(activitat_modificar_id).toString());
				
				//Desem els corresponents percentatges de cadascuna de les arees que conformen aquesta activitat avaluadora
				while (index.hasNext()){
					
					try{
						
						percentatgeStr = value.next();
						System.out.println("percentatge "+percentatgeStr);
						indexString = index.next();
						System.out.println("indexString "+indexString);
						areaAssignaturaIdStr = arees.next();
						System.out.println("areaAssignaturaIdStr "+areaAssignaturaIdStr);
						if(percentatgeStr != ""){
							if (indexString == ""){
								//Si no hi havia valor per a la areaActivitat.id significa que l'has de crear
								Long id = areaActivitatService.guardaAreaActivitat(areaAssignaturaService.obteAreaAssignatura(Long.parseLong(areaAssignaturaIdStr)), activitatAvaluadoraModificar, Double.parseDouble(percentatgeStr));
								System.out.println("Identificador nova areaActivitat "+ id);
								
							}else{
								//Si hi ha un id de areaActivitat (indexString) es modifica
								areaActivitatId = Long.parseLong(indexString);
								System.out.println("areaActividadId "+areaActivitatId);
								AreaActivitat areaActivitatModificar = areaActivitatService.obteAreaActivitat(areaActivitatId);
								System.out.println("areaActivitatModificar abans "+areaActivitatModificar.toString());
								areaActivitatModificar.setPercentatgeProgramacio(Double.parseDouble(percentatgeStr));
								System.out.println("areaActivitatModificar despres "+areaActivitatModificar.toString());
								areaActivitatService.actualizaAreaActivitat(areaActivitatModificar);	
								System.out.println(""+areaActivitatService.obteAreaActivitat(areaActivitatId));
							}
						}
					}
					catch (Exception e){
						
						model.addAttribute("adviceMessage", "Als percentatges noms es poden introduir nombres. <br>"
								+ "Comproveu la darrera activitat que acabeu de modificar.");
						System.out.println("Entra al cath");
						model.addAttribute("activitats", activitatAvaluadoraService.obteLlistaActivitatAvaluadoraAlta(unitat_selected));
						return "P5_programacio_activitats_avaluables";
						
					}			
				}
				model.addAttribute("activitats", activitatAvaluadoraService.obteLlistaActivitatAvaluadoraAlta(unitat_selected));
		}
	
	
		
	return "P5_programacio_activitats_avaluables";
			
			
	}

}
